// $ANTLR 3.5 org/apiwatch/analyser/c/C.g 2013-02-09 00:49:39

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 2012, Robin Jarry, All rights reserved.               *
 *                                                                     *
 * This file is part of APIWATCH and published under the BSD license.  *
 *                                                                     *
 * See the "LICENSE" file for more information.                        *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
package org.apiwatch.analyser.c;
 
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apiwatch.analyser.c.Header;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class CLexer extends Lexer {
	public static final int EOF=-1;
	public static final int AND=4;
	public static final int AND_ASSIGN=5;
	public static final int ARRAY_ACCESS=6;
	public static final int ARRAY_DECL=7;
	public static final int ARROW=8;
	public static final int ASM=9;
	public static final int ASSIGN=10;
	public static final int ATTRIBUTE=11;
	public static final int AUTO=12;
	public static final int BIT_COUNT=13;
	public static final int BREAK=14;
	public static final int CALL=15;
	public static final int CASE=16;
	public static final int CAST=17;
	public static final int CHAR=18;
	public static final int CHARACTER_LITERAL=19;
	public static final int COLON=20;
	public static final int COMMA=21;
	public static final int COMMENT=22;
	public static final int CONST=23;
	public static final int CONTINUE=24;
	public static final int C_SOURCE=25;
	public static final int DECIMAL_LITERAL=26;
	public static final int DECLARATOR=27;
	public static final int DECLSPEC=28;
	public static final int DECL_SPECIFIERS=29;
	public static final int DECR=30;
	public static final int DEFAULT=31;
	public static final int DIV=32;
	public static final int DIV_ASSIGN=33;
	public static final int DO=34;
	public static final int DOT=35;
	public static final int DOUBLE=36;
	public static final int ELLIPSIS=37;
	public static final int ELSE=38;
	public static final int ENUM=39;
	public static final int ENUMERATOR=40;
	public static final int EQUAL=41;
	public static final int EXTENSION=42;
	public static final int EXTERN=43;
	public static final int EscapeSequence=44;
	public static final int Exponent=45;
	public static final int FIELD=46;
	public static final int FLOAT=47;
	public static final int FLOATING_POINT_LITERAL=48;
	public static final int FOR=49;
	public static final int FUNCTION_ARGS=50;
	public static final int FUNCTION_DECLARATION=51;
	public static final int FUNCTION_DEFINITION=52;
	public static final int FloatTypeSuffix=53;
	public static final int GOTO=54;
	public static final int GREATER_OR_EQUAL=55;
	public static final int GREATER_THAN=56;
	public static final int HEX_LITERAL=57;
	public static final int HexDigit=58;
	public static final int IDENTIFIER=59;
	public static final int IDENTIFIER_LIST=60;
	public static final int IF=61;
	public static final int INCR=62;
	public static final int INLINE=63;
	public static final int INT=64;
	public static final int IntegerTypeSuffix=65;
	public static final int LBRACK=66;
	public static final int LCURLY=67;
	public static final int LESS_OR_EQUAL=68;
	public static final int LESS_THAN=69;
	public static final int LETTER=70;
	public static final int LINE_COMMENT=71;
	public static final int LOGICAL_AND=72;
	public static final int LOGICAL_NOT=73;
	public static final int LOGICAL_OR=74;
	public static final int LONG=75;
	public static final int LPAREN=76;
	public static final int MINUS=77;
	public static final int MINUS_ASSIGN=78;
	public static final int MOD=79;
	public static final int MODIFIER=80;
	public static final int MOD_ASSIGN=81;
	public static final int NOT=82;
	public static final int NOT_EQUAL=83;
	public static final int OCTAL_LITERAL=84;
	public static final int OR=85;
	public static final int OR_ASSIGN=86;
	public static final int OctalEscape=87;
	public static final int PARAM=88;
	public static final int PLUS=89;
	public static final int PLUS_ASSIGN=90;
	public static final int POINTER=91;
	public static final int POST_DECR=92;
	public static final int POST_INCR=93;
	public static final int PREPROCESSOR_COMMAND=94;
	public static final int PRE_DECR=95;
	public static final int PRE_INCR=96;
	public static final int QUESTION=97;
	public static final int RBRACK=98;
	public static final int RCURLY=99;
	public static final int REGISTER=100;
	public static final int RESTRICT=101;
	public static final int RETURN=102;
	public static final int RPAREN=103;
	public static final int SEMI=104;
	public static final int SHIFT_LEFT=105;
	public static final int SHIFT_LEFT_ASSIGN=106;
	public static final int SHIFT_RIGHT=107;
	public static final int SHIFT_RIGHT_ASSIGN=108;
	public static final int SHORT=109;
	public static final int SIGNED=110;
	public static final int SIZEOF=111;
	public static final int STAR=112;
	public static final int STAR_ASSIGN=113;
	public static final int STATIC=114;
	public static final int STRING_LITERAL=115;
	public static final int STRUCT=116;
	public static final int STRUCTURE=117;
	public static final int SWITCH=118;
	public static final int TYPE=119;
	public static final int TYPEDEF=120;
	public static final int TYPE_DECLARATION=121;
	public static final int UNION=122;
	public static final int UNSIGNED=123;
	public static final int UnicodeEscape=124;
	public static final int VARIABLE_DECLARATION=125;
	public static final int VOID=126;
	public static final int VOLATILE=127;
	public static final int WHILE=128;
	public static final int WS=129;
	public static final int XOR=130;
	public static final int XOR_ASSIGN=131;


	public List<String> systemPaths;
	public List<Header> headers; 
	private static final Pattern PREPROC_LINE = Pattern.compile("#\\s*(\\d+)\\s*\"(.+?)\"");

	// special constructor
	public CLexer(CharStream input, List<String> systemPaths) {
	    this(input, new RecognizerSharedState());
	    this.systemPaths = systemPaths != null ? systemPaths : new ArrayList<String>();
	    this.headers = new ArrayList<Header>();
	}

	private void recordHeader(int line, String text) {
	    text = text.replace("\\\\", "\\"); // for windows paths
	    Matcher match = PREPROC_LINE.matcher(text);
	    if (match.find()) {
			    int sourceLine = Integer.valueOf(match.group(1));
			    String sourceFile = match.group(2);
			    boolean isSystemHeader = false;
	        // ignore case and file path separator.
			    String source = sourceFile.toLowerCase().replace("\\", "/");
	        for (String path : systemPaths) {
	            if (source.startsWith(path.replace("\\", "/").toLowerCase())) {
	                isSystemHeader = true;
	                break;
	            }
	        }
	        headers.add(new Header(line, isSystemHeader, sourceLine, sourceFile));
	    }
	}
	    


	// delegates
	// delegators
	public Lexer[] getDelegates() {
		return new Lexer[] {};
	}

	public CLexer() {} 
	public CLexer(CharStream input) {
		this(input, new RecognizerSharedState());
	}
	public CLexer(CharStream input, RecognizerSharedState state) {
		super(input,state);
	}
	@Override public String getGrammarFileName() { return "org/apiwatch/analyser/c/C.g"; }

	// $ANTLR start "AND"
	public final void mAND() throws RecognitionException {
		try {
			int _type = AND;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:699:20: ( '&' )
			// org/apiwatch/analyser/c/C.g:699:22: '&'
			{
			match('&'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "AND"

	// $ANTLR start "AND_ASSIGN"
	public final void mAND_ASSIGN() throws RecognitionException {
		try {
			int _type = AND_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:700:20: ( '&=' )
			// org/apiwatch/analyser/c/C.g:700:22: '&='
			{
			match("&="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "AND_ASSIGN"

	// $ANTLR start "ASSIGN"
	public final void mASSIGN() throws RecognitionException {
		try {
			int _type = ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:701:20: ( '=' )
			// org/apiwatch/analyser/c/C.g:701:22: '='
			{
			match('='); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ASSIGN"

	// $ANTLR start "ARROW"
	public final void mARROW() throws RecognitionException {
		try {
			int _type = ARROW;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:702:20: ( '->' )
			// org/apiwatch/analyser/c/C.g:702:22: '->'
			{
			match("->"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ARROW"

	// $ANTLR start "COLON"
	public final void mCOLON() throws RecognitionException {
		try {
			int _type = COLON;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:703:20: ( ':' )
			// org/apiwatch/analyser/c/C.g:703:22: ':'
			{
			match(':'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "COLON"

	// $ANTLR start "COMMA"
	public final void mCOMMA() throws RecognitionException {
		try {
			int _type = COMMA;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:704:20: ( ',' )
			// org/apiwatch/analyser/c/C.g:704:22: ','
			{
			match(','); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "COMMA"

	// $ANTLR start "DECR"
	public final void mDECR() throws RecognitionException {
		try {
			int _type = DECR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:705:20: ( '--' )
			// org/apiwatch/analyser/c/C.g:705:22: '--'
			{
			match("--"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DECR"

	// $ANTLR start "DIV"
	public final void mDIV() throws RecognitionException {
		try {
			int _type = DIV;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:706:20: ( '/' )
			// org/apiwatch/analyser/c/C.g:706:22: '/'
			{
			match('/'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DIV"

	// $ANTLR start "DIV_ASSIGN"
	public final void mDIV_ASSIGN() throws RecognitionException {
		try {
			int _type = DIV_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:707:20: ( '/=' )
			// org/apiwatch/analyser/c/C.g:707:22: '/='
			{
			match("/="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DIV_ASSIGN"

	// $ANTLR start "DOT"
	public final void mDOT() throws RecognitionException {
		try {
			int _type = DOT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:708:20: ( '.' )
			// org/apiwatch/analyser/c/C.g:708:22: '.'
			{
			match('.'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DOT"

	// $ANTLR start "ELLIPSIS"
	public final void mELLIPSIS() throws RecognitionException {
		try {
			int _type = ELLIPSIS;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:709:20: ( '...' )
			// org/apiwatch/analyser/c/C.g:709:22: '...'
			{
			match("..."); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ELLIPSIS"

	// $ANTLR start "EQUAL"
	public final void mEQUAL() throws RecognitionException {
		try {
			int _type = EQUAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:710:20: ( '==' )
			// org/apiwatch/analyser/c/C.g:710:22: '=='
			{
			match("=="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "EQUAL"

	// $ANTLR start "GREATER_OR_EQUAL"
	public final void mGREATER_OR_EQUAL() throws RecognitionException {
		try {
			int _type = GREATER_OR_EQUAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:711:20: ( '>=' )
			// org/apiwatch/analyser/c/C.g:711:22: '>='
			{
			match(">="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "GREATER_OR_EQUAL"

	// $ANTLR start "GREATER_THAN"
	public final void mGREATER_THAN() throws RecognitionException {
		try {
			int _type = GREATER_THAN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:712:20: ( '>' )
			// org/apiwatch/analyser/c/C.g:712:22: '>'
			{
			match('>'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "GREATER_THAN"

	// $ANTLR start "INCR"
	public final void mINCR() throws RecognitionException {
		try {
			int _type = INCR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:713:20: ( '++' )
			// org/apiwatch/analyser/c/C.g:713:22: '++'
			{
			match("++"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "INCR"

	// $ANTLR start "LBRACK"
	public final void mLBRACK() throws RecognitionException {
		try {
			int _type = LBRACK;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:714:20: ( '[' )
			// org/apiwatch/analyser/c/C.g:714:22: '['
			{
			match('['); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LBRACK"

	// $ANTLR start "LCURLY"
	public final void mLCURLY() throws RecognitionException {
		try {
			int _type = LCURLY;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:715:20: ( '{' )
			// org/apiwatch/analyser/c/C.g:715:22: '{'
			{
			match('{'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LCURLY"

	// $ANTLR start "LESS_OR_EQUAL"
	public final void mLESS_OR_EQUAL() throws RecognitionException {
		try {
			int _type = LESS_OR_EQUAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:716:20: ( '<=' )
			// org/apiwatch/analyser/c/C.g:716:22: '<='
			{
			match("<="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LESS_OR_EQUAL"

	// $ANTLR start "LESS_THAN"
	public final void mLESS_THAN() throws RecognitionException {
		try {
			int _type = LESS_THAN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:717:20: ( '<' )
			// org/apiwatch/analyser/c/C.g:717:22: '<'
			{
			match('<'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LESS_THAN"

	// $ANTLR start "LOGICAL_AND"
	public final void mLOGICAL_AND() throws RecognitionException {
		try {
			int _type = LOGICAL_AND;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:718:20: ( '&&' )
			// org/apiwatch/analyser/c/C.g:718:22: '&&'
			{
			match("&&"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LOGICAL_AND"

	// $ANTLR start "LOGICAL_NOT"
	public final void mLOGICAL_NOT() throws RecognitionException {
		try {
			int _type = LOGICAL_NOT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:719:20: ( '!' )
			// org/apiwatch/analyser/c/C.g:719:22: '!'
			{
			match('!'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LOGICAL_NOT"

	// $ANTLR start "LOGICAL_OR"
	public final void mLOGICAL_OR() throws RecognitionException {
		try {
			int _type = LOGICAL_OR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:720:20: ( '||' )
			// org/apiwatch/analyser/c/C.g:720:22: '||'
			{
			match("||"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LOGICAL_OR"

	// $ANTLR start "LPAREN"
	public final void mLPAREN() throws RecognitionException {
		try {
			int _type = LPAREN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:721:20: ( '(' )
			// org/apiwatch/analyser/c/C.g:721:22: '('
			{
			match('('); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LPAREN"

	// $ANTLR start "MINUS"
	public final void mMINUS() throws RecognitionException {
		try {
			int _type = MINUS;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:722:20: ( '-' )
			// org/apiwatch/analyser/c/C.g:722:22: '-'
			{
			match('-'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "MINUS"

	// $ANTLR start "MINUS_ASSIGN"
	public final void mMINUS_ASSIGN() throws RecognitionException {
		try {
			int _type = MINUS_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:723:20: ( '-=' )
			// org/apiwatch/analyser/c/C.g:723:22: '-='
			{
			match("-="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "MINUS_ASSIGN"

	// $ANTLR start "MOD"
	public final void mMOD() throws RecognitionException {
		try {
			int _type = MOD;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:724:20: ( '%' )
			// org/apiwatch/analyser/c/C.g:724:22: '%'
			{
			match('%'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "MOD"

	// $ANTLR start "MOD_ASSIGN"
	public final void mMOD_ASSIGN() throws RecognitionException {
		try {
			int _type = MOD_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:725:20: ( '%=' )
			// org/apiwatch/analyser/c/C.g:725:22: '%='
			{
			match("%="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "MOD_ASSIGN"

	// $ANTLR start "NOT"
	public final void mNOT() throws RecognitionException {
		try {
			int _type = NOT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:726:20: ( '~' )
			// org/apiwatch/analyser/c/C.g:726:22: '~'
			{
			match('~'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "NOT"

	// $ANTLR start "NOT_EQUAL"
	public final void mNOT_EQUAL() throws RecognitionException {
		try {
			int _type = NOT_EQUAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:727:20: ( '!=' )
			// org/apiwatch/analyser/c/C.g:727:22: '!='
			{
			match("!="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "NOT_EQUAL"

	// $ANTLR start "OR"
	public final void mOR() throws RecognitionException {
		try {
			int _type = OR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:728:20: ( '|' )
			// org/apiwatch/analyser/c/C.g:728:22: '|'
			{
			match('|'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "OR"

	// $ANTLR start "OR_ASSIGN"
	public final void mOR_ASSIGN() throws RecognitionException {
		try {
			int _type = OR_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:729:20: ( '|=' )
			// org/apiwatch/analyser/c/C.g:729:22: '|='
			{
			match("|="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "OR_ASSIGN"

	// $ANTLR start "PLUS"
	public final void mPLUS() throws RecognitionException {
		try {
			int _type = PLUS;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:730:20: ( '+' )
			// org/apiwatch/analyser/c/C.g:730:22: '+'
			{
			match('+'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "PLUS"

	// $ANTLR start "PLUS_ASSIGN"
	public final void mPLUS_ASSIGN() throws RecognitionException {
		try {
			int _type = PLUS_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:731:20: ( '+=' )
			// org/apiwatch/analyser/c/C.g:731:22: '+='
			{
			match("+="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "PLUS_ASSIGN"

	// $ANTLR start "QUESTION"
	public final void mQUESTION() throws RecognitionException {
		try {
			int _type = QUESTION;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:732:20: ( '?' )
			// org/apiwatch/analyser/c/C.g:732:22: '?'
			{
			match('?'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "QUESTION"

	// $ANTLR start "RBRACK"
	public final void mRBRACK() throws RecognitionException {
		try {
			int _type = RBRACK;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:733:20: ( ']' )
			// org/apiwatch/analyser/c/C.g:733:22: ']'
			{
			match(']'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RBRACK"

	// $ANTLR start "RCURLY"
	public final void mRCURLY() throws RecognitionException {
		try {
			int _type = RCURLY;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:734:20: ( '}' )
			// org/apiwatch/analyser/c/C.g:734:22: '}'
			{
			match('}'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RCURLY"

	// $ANTLR start "RPAREN"
	public final void mRPAREN() throws RecognitionException {
		try {
			int _type = RPAREN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:735:20: ( ')' )
			// org/apiwatch/analyser/c/C.g:735:22: ')'
			{
			match(')'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RPAREN"

	// $ANTLR start "SEMI"
	public final void mSEMI() throws RecognitionException {
		try {
			int _type = SEMI;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:736:20: ( ';' )
			// org/apiwatch/analyser/c/C.g:736:22: ';'
			{
			match(';'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SEMI"

	// $ANTLR start "SHIFT_LEFT"
	public final void mSHIFT_LEFT() throws RecognitionException {
		try {
			int _type = SHIFT_LEFT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:737:20: ( '<<' )
			// org/apiwatch/analyser/c/C.g:737:22: '<<'
			{
			match("<<"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SHIFT_LEFT"

	// $ANTLR start "SHIFT_LEFT_ASSIGN"
	public final void mSHIFT_LEFT_ASSIGN() throws RecognitionException {
		try {
			int _type = SHIFT_LEFT_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:738:20: ( '<<=' )
			// org/apiwatch/analyser/c/C.g:738:22: '<<='
			{
			match("<<="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SHIFT_LEFT_ASSIGN"

	// $ANTLR start "SHIFT_RIGHT"
	public final void mSHIFT_RIGHT() throws RecognitionException {
		try {
			int _type = SHIFT_RIGHT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:739:20: ( '>>' )
			// org/apiwatch/analyser/c/C.g:739:22: '>>'
			{
			match(">>"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SHIFT_RIGHT"

	// $ANTLR start "SHIFT_RIGHT_ASSIGN"
	public final void mSHIFT_RIGHT_ASSIGN() throws RecognitionException {
		try {
			int _type = SHIFT_RIGHT_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:740:20: ( '>>=' )
			// org/apiwatch/analyser/c/C.g:740:22: '>>='
			{
			match(">>="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SHIFT_RIGHT_ASSIGN"

	// $ANTLR start "STAR"
	public final void mSTAR() throws RecognitionException {
		try {
			int _type = STAR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:741:20: ( '*' )
			// org/apiwatch/analyser/c/C.g:741:22: '*'
			{
			match('*'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STAR"

	// $ANTLR start "STAR_ASSIGN"
	public final void mSTAR_ASSIGN() throws RecognitionException {
		try {
			int _type = STAR_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:742:20: ( '*=' )
			// org/apiwatch/analyser/c/C.g:742:22: '*='
			{
			match("*="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STAR_ASSIGN"

	// $ANTLR start "XOR"
	public final void mXOR() throws RecognitionException {
		try {
			int _type = XOR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:743:20: ( '^' )
			// org/apiwatch/analyser/c/C.g:743:22: '^'
			{
			match('^'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "XOR"

	// $ANTLR start "XOR_ASSIGN"
	public final void mXOR_ASSIGN() throws RecognitionException {
		try {
			int _type = XOR_ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:744:20: ( '^=' )
			// org/apiwatch/analyser/c/C.g:744:22: '^='
			{
			match("^="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "XOR_ASSIGN"

	// $ANTLR start "ASM"
	public final void mASM() throws RecognitionException {
		try {
			int _type = ASM;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:747:20: ( 'asm' | '__asm__' | '__asm' )
			int alt1=3;
			int LA1_0 = input.LA(1);
			if ( (LA1_0=='a') ) {
				alt1=1;
			}
			else if ( (LA1_0=='_') ) {
				int LA1_2 = input.LA(2);
				if ( (LA1_2=='_') ) {
					int LA1_3 = input.LA(3);
					if ( (LA1_3=='a') ) {
						int LA1_4 = input.LA(4);
						if ( (LA1_4=='s') ) {
							int LA1_5 = input.LA(5);
							if ( (LA1_5=='m') ) {
								int LA1_6 = input.LA(6);
								if ( (LA1_6=='_') ) {
									alt1=2;
								}

								else {
									alt1=3;
								}

							}

							else {
								int nvaeMark = input.mark();
								try {
									for (int nvaeConsume = 0; nvaeConsume < 5 - 1; nvaeConsume++) {
										input.consume();
									}
									NoViableAltException nvae =
										new NoViableAltException("", 1, 5, input);
									throw nvae;
								} finally {
									input.rewind(nvaeMark);
								}
							}

						}

						else {
							int nvaeMark = input.mark();
							try {
								for (int nvaeConsume = 0; nvaeConsume < 4 - 1; nvaeConsume++) {
									input.consume();
								}
								NoViableAltException nvae =
									new NoViableAltException("", 1, 4, input);
								throw nvae;
							} finally {
								input.rewind(nvaeMark);
							}
						}

					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 1, 3, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 1, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 1, 0, input);
				throw nvae;
			}

			switch (alt1) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:747:22: 'asm'
					{
					match("asm"); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:747:28: '__asm__'
					{
					match("__asm__"); 

					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:747:38: '__asm'
					{
					match("__asm"); 

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ASM"

	// $ANTLR start "AUTO"
	public final void mAUTO() throws RecognitionException {
		try {
			int _type = AUTO;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:748:20: ( 'auto' )
			// org/apiwatch/analyser/c/C.g:748:22: 'auto'
			{
			match("auto"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "AUTO"

	// $ANTLR start "BREAK"
	public final void mBREAK() throws RecognitionException {
		try {
			int _type = BREAK;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:749:20: ( 'break' )
			// org/apiwatch/analyser/c/C.g:749:22: 'break'
			{
			match("break"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "BREAK"

	// $ANTLR start "CASE"
	public final void mCASE() throws RecognitionException {
		try {
			int _type = CASE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:750:20: ( 'case' )
			// org/apiwatch/analyser/c/C.g:750:22: 'case'
			{
			match("case"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CASE"

	// $ANTLR start "CHAR"
	public final void mCHAR() throws RecognitionException {
		try {
			int _type = CHAR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:751:20: ( 'char' )
			// org/apiwatch/analyser/c/C.g:751:22: 'char'
			{
			match("char"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CHAR"

	// $ANTLR start "CONST"
	public final void mCONST() throws RecognitionException {
		try {
			int _type = CONST;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:752:20: ( 'const' | '__const' )
			int alt2=2;
			int LA2_0 = input.LA(1);
			if ( (LA2_0=='c') ) {
				alt2=1;
			}
			else if ( (LA2_0=='_') ) {
				alt2=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 2, 0, input);
				throw nvae;
			}

			switch (alt2) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:752:22: 'const'
					{
					match("const"); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:752:30: '__const'
					{
					match("__const"); 

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CONST"

	// $ANTLR start "CONTINUE"
	public final void mCONTINUE() throws RecognitionException {
		try {
			int _type = CONTINUE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:753:20: ( 'continue' )
			// org/apiwatch/analyser/c/C.g:753:22: 'continue'
			{
			match("continue"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CONTINUE"

	// $ANTLR start "DEFAULT"
	public final void mDEFAULT() throws RecognitionException {
		try {
			int _type = DEFAULT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:754:20: ( 'default' )
			// org/apiwatch/analyser/c/C.g:754:22: 'default'
			{
			match("default"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DEFAULT"

	// $ANTLR start "DECLSPEC"
	public final void mDECLSPEC() throws RecognitionException {
		try {
			int _type = DECLSPEC;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:755:20: ( '__declspec' )
			// org/apiwatch/analyser/c/C.g:755:22: '__declspec'
			{
			match("__declspec"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DECLSPEC"

	// $ANTLR start "DO"
	public final void mDO() throws RecognitionException {
		try {
			int _type = DO;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:756:20: ( 'do' )
			// org/apiwatch/analyser/c/C.g:756:22: 'do'
			{
			match("do"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DO"

	// $ANTLR start "DOUBLE"
	public final void mDOUBLE() throws RecognitionException {
		try {
			int _type = DOUBLE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:757:20: ( 'double' )
			// org/apiwatch/analyser/c/C.g:757:22: 'double'
			{
			match("double"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DOUBLE"

	// $ANTLR start "ELSE"
	public final void mELSE() throws RecognitionException {
		try {
			int _type = ELSE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:758:20: ( 'else' )
			// org/apiwatch/analyser/c/C.g:758:22: 'else'
			{
			match("else"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ELSE"

	// $ANTLR start "ENUM"
	public final void mENUM() throws RecognitionException {
		try {
			int _type = ENUM;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:759:20: ( 'enum' )
			// org/apiwatch/analyser/c/C.g:759:22: 'enum'
			{
			match("enum"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ENUM"

	// $ANTLR start "EXTERN"
	public final void mEXTERN() throws RecognitionException {
		try {
			int _type = EXTERN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:760:20: ( 'extern' )
			// org/apiwatch/analyser/c/C.g:760:22: 'extern'
			{
			match("extern"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "EXTERN"

	// $ANTLR start "EXTENSION"
	public final void mEXTENSION() throws RecognitionException {
		try {
			int _type = EXTENSION;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:761:20: ( '__extension__' )
			// org/apiwatch/analyser/c/C.g:761:22: '__extension__'
			{
			match("__extension__"); 

			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "EXTENSION"

	// $ANTLR start "FLOAT"
	public final void mFLOAT() throws RecognitionException {
		try {
			int _type = FLOAT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:762:20: ( 'float' )
			// org/apiwatch/analyser/c/C.g:762:22: 'float'
			{
			match("float"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FLOAT"

	// $ANTLR start "FOR"
	public final void mFOR() throws RecognitionException {
		try {
			int _type = FOR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:763:20: ( 'for' )
			// org/apiwatch/analyser/c/C.g:763:22: 'for'
			{
			match("for"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FOR"

	// $ANTLR start "ATTRIBUTE"
	public final void mATTRIBUTE() throws RecognitionException {
		try {
			int _type = ATTRIBUTE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:764:20: ( '__attribute__' )
			// org/apiwatch/analyser/c/C.g:764:22: '__attribute__'
			{
			match("__attribute__"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ATTRIBUTE"

	// $ANTLR start "GOTO"
	public final void mGOTO() throws RecognitionException {
		try {
			int _type = GOTO;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:765:20: ( 'goto' )
			// org/apiwatch/analyser/c/C.g:765:22: 'goto'
			{
			match("goto"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "GOTO"

	// $ANTLR start "IF"
	public final void mIF() throws RecognitionException {
		try {
			int _type = IF;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:766:20: ( 'if' )
			// org/apiwatch/analyser/c/C.g:766:22: 'if'
			{
			match("if"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "IF"

	// $ANTLR start "INT"
	public final void mINT() throws RecognitionException {
		try {
			int _type = INT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:767:20: ( 'int' )
			// org/apiwatch/analyser/c/C.g:767:22: 'int'
			{
			match("int"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "INT"

	// $ANTLR start "INLINE"
	public final void mINLINE() throws RecognitionException {
		try {
			int _type = INLINE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:768:20: ( 'inline' | '__inline__' | '__inline' )
			int alt3=3;
			int LA3_0 = input.LA(1);
			if ( (LA3_0=='i') ) {
				alt3=1;
			}
			else if ( (LA3_0=='_') ) {
				int LA3_2 = input.LA(2);
				if ( (LA3_2=='_') ) {
					int LA3_3 = input.LA(3);
					if ( (LA3_3=='i') ) {
						int LA3_4 = input.LA(4);
						if ( (LA3_4=='n') ) {
							int LA3_5 = input.LA(5);
							if ( (LA3_5=='l') ) {
								int LA3_6 = input.LA(6);
								if ( (LA3_6=='i') ) {
									int LA3_7 = input.LA(7);
									if ( (LA3_7=='n') ) {
										int LA3_8 = input.LA(8);
										if ( (LA3_8=='e') ) {
											int LA3_9 = input.LA(9);
											if ( (LA3_9=='_') ) {
												alt3=2;
											}

											else {
												alt3=3;
											}

										}

										else {
											int nvaeMark = input.mark();
											try {
												for (int nvaeConsume = 0; nvaeConsume < 8 - 1; nvaeConsume++) {
													input.consume();
												}
												NoViableAltException nvae =
													new NoViableAltException("", 3, 8, input);
												throw nvae;
											} finally {
												input.rewind(nvaeMark);
											}
										}

									}

									else {
										int nvaeMark = input.mark();
										try {
											for (int nvaeConsume = 0; nvaeConsume < 7 - 1; nvaeConsume++) {
												input.consume();
											}
											NoViableAltException nvae =
												new NoViableAltException("", 3, 7, input);
											throw nvae;
										} finally {
											input.rewind(nvaeMark);
										}
									}

								}

								else {
									int nvaeMark = input.mark();
									try {
										for (int nvaeConsume = 0; nvaeConsume < 6 - 1; nvaeConsume++) {
											input.consume();
										}
										NoViableAltException nvae =
											new NoViableAltException("", 3, 6, input);
										throw nvae;
									} finally {
										input.rewind(nvaeMark);
									}
								}

							}

							else {
								int nvaeMark = input.mark();
								try {
									for (int nvaeConsume = 0; nvaeConsume < 5 - 1; nvaeConsume++) {
										input.consume();
									}
									NoViableAltException nvae =
										new NoViableAltException("", 3, 5, input);
									throw nvae;
								} finally {
									input.rewind(nvaeMark);
								}
							}

						}

						else {
							int nvaeMark = input.mark();
							try {
								for (int nvaeConsume = 0; nvaeConsume < 4 - 1; nvaeConsume++) {
									input.consume();
								}
								NoViableAltException nvae =
									new NoViableAltException("", 3, 4, input);
								throw nvae;
							} finally {
								input.rewind(nvaeMark);
							}
						}

					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 3, 3, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 3, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 3, 0, input);
				throw nvae;
			}

			switch (alt3) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:768:22: 'inline'
					{
					match("inline"); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:768:31: '__inline__'
					{
					match("__inline__"); 

					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:768:44: '__inline'
					{
					match("__inline"); 

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "INLINE"

	// $ANTLR start "LONG"
	public final void mLONG() throws RecognitionException {
		try {
			int _type = LONG;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:769:20: ( 'long' )
			// org/apiwatch/analyser/c/C.g:769:22: 'long'
			{
			match("long"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LONG"

	// $ANTLR start "REGISTER"
	public final void mREGISTER() throws RecognitionException {
		try {
			int _type = REGISTER;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:770:20: ( 'register' )
			// org/apiwatch/analyser/c/C.g:770:22: 'register'
			{
			match("register"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "REGISTER"

	// $ANTLR start "RESTRICT"
	public final void mRESTRICT() throws RecognitionException {
		try {
			int _type = RESTRICT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:771:20: ( ( 'restrict' | '__restrict' | '__restrict__' ) )
			// org/apiwatch/analyser/c/C.g:771:22: ( 'restrict' | '__restrict' | '__restrict__' )
			{
			// org/apiwatch/analyser/c/C.g:771:22: ( 'restrict' | '__restrict' | '__restrict__' )
			int alt4=3;
			int LA4_0 = input.LA(1);
			if ( (LA4_0=='r') ) {
				alt4=1;
			}
			else if ( (LA4_0=='_') ) {
				int LA4_2 = input.LA(2);
				if ( (LA4_2=='_') ) {
					int LA4_3 = input.LA(3);
					if ( (LA4_3=='r') ) {
						int LA4_4 = input.LA(4);
						if ( (LA4_4=='e') ) {
							int LA4_5 = input.LA(5);
							if ( (LA4_5=='s') ) {
								int LA4_6 = input.LA(6);
								if ( (LA4_6=='t') ) {
									int LA4_7 = input.LA(7);
									if ( (LA4_7=='r') ) {
										int LA4_8 = input.LA(8);
										if ( (LA4_8=='i') ) {
											int LA4_9 = input.LA(9);
											if ( (LA4_9=='c') ) {
												int LA4_10 = input.LA(10);
												if ( (LA4_10=='t') ) {
													int LA4_11 = input.LA(11);
													if ( (LA4_11=='_') ) {
														alt4=3;
													}

													else {
														alt4=2;
													}

												}

												else {
													int nvaeMark = input.mark();
													try {
														for (int nvaeConsume = 0; nvaeConsume < 10 - 1; nvaeConsume++) {
															input.consume();
														}
														NoViableAltException nvae =
															new NoViableAltException("", 4, 10, input);
														throw nvae;
													} finally {
														input.rewind(nvaeMark);
													}
												}

											}

											else {
												int nvaeMark = input.mark();
												try {
													for (int nvaeConsume = 0; nvaeConsume < 9 - 1; nvaeConsume++) {
														input.consume();
													}
													NoViableAltException nvae =
														new NoViableAltException("", 4, 9, input);
													throw nvae;
												} finally {
													input.rewind(nvaeMark);
												}
											}

										}

										else {
											int nvaeMark = input.mark();
											try {
												for (int nvaeConsume = 0; nvaeConsume < 8 - 1; nvaeConsume++) {
													input.consume();
												}
												NoViableAltException nvae =
													new NoViableAltException("", 4, 8, input);
												throw nvae;
											} finally {
												input.rewind(nvaeMark);
											}
										}

									}

									else {
										int nvaeMark = input.mark();
										try {
											for (int nvaeConsume = 0; nvaeConsume < 7 - 1; nvaeConsume++) {
												input.consume();
											}
											NoViableAltException nvae =
												new NoViableAltException("", 4, 7, input);
											throw nvae;
										} finally {
											input.rewind(nvaeMark);
										}
									}

								}

								else {
									int nvaeMark = input.mark();
									try {
										for (int nvaeConsume = 0; nvaeConsume < 6 - 1; nvaeConsume++) {
											input.consume();
										}
										NoViableAltException nvae =
											new NoViableAltException("", 4, 6, input);
										throw nvae;
									} finally {
										input.rewind(nvaeMark);
									}
								}

							}

							else {
								int nvaeMark = input.mark();
								try {
									for (int nvaeConsume = 0; nvaeConsume < 5 - 1; nvaeConsume++) {
										input.consume();
									}
									NoViableAltException nvae =
										new NoViableAltException("", 4, 5, input);
									throw nvae;
								} finally {
									input.rewind(nvaeMark);
								}
							}

						}

						else {
							int nvaeMark = input.mark();
							try {
								for (int nvaeConsume = 0; nvaeConsume < 4 - 1; nvaeConsume++) {
									input.consume();
								}
								NoViableAltException nvae =
									new NoViableAltException("", 4, 4, input);
								throw nvae;
							} finally {
								input.rewind(nvaeMark);
							}
						}

					}

					else {
						int nvaeMark = input.mark();
						try {
							for (int nvaeConsume = 0; nvaeConsume < 3 - 1; nvaeConsume++) {
								input.consume();
							}
							NoViableAltException nvae =
								new NoViableAltException("", 4, 3, input);
							throw nvae;
						} finally {
							input.rewind(nvaeMark);
						}
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 4, 2, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 4, 0, input);
				throw nvae;
			}

			switch (alt4) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:771:23: 'restrict'
					{
					match("restrict"); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:771:34: '__restrict'
					{
					match("__restrict"); 

					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:771:47: '__restrict__'
					{
					match("__restrict__"); 

					}
					break;

			}

			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RESTRICT"

	// $ANTLR start "RETURN"
	public final void mRETURN() throws RecognitionException {
		try {
			int _type = RETURN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:772:20: ( 'return' )
			// org/apiwatch/analyser/c/C.g:772:22: 'return'
			{
			match("return"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RETURN"

	// $ANTLR start "SHORT"
	public final void mSHORT() throws RecognitionException {
		try {
			int _type = SHORT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:773:20: ( 'short' )
			// org/apiwatch/analyser/c/C.g:773:22: 'short'
			{
			match("short"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SHORT"

	// $ANTLR start "SIGNED"
	public final void mSIGNED() throws RecognitionException {
		try {
			int _type = SIGNED;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:774:20: ( 'signed' )
			// org/apiwatch/analyser/c/C.g:774:22: 'signed'
			{
			match("signed"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SIGNED"

	// $ANTLR start "SIZEOF"
	public final void mSIZEOF() throws RecognitionException {
		try {
			int _type = SIZEOF;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:775:20: ( 'sizeof' )
			// org/apiwatch/analyser/c/C.g:775:22: 'sizeof'
			{
			match("sizeof"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SIZEOF"

	// $ANTLR start "STATIC"
	public final void mSTATIC() throws RecognitionException {
		try {
			int _type = STATIC;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:776:20: ( 'static' )
			// org/apiwatch/analyser/c/C.g:776:22: 'static'
			{
			match("static"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STATIC"

	// $ANTLR start "STRUCT"
	public final void mSTRUCT() throws RecognitionException {
		try {
			int _type = STRUCT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:777:20: ( 'struct' )
			// org/apiwatch/analyser/c/C.g:777:22: 'struct'
			{
			match("struct"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STRUCT"

	// $ANTLR start "SWITCH"
	public final void mSWITCH() throws RecognitionException {
		try {
			int _type = SWITCH;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:778:20: ( 'switch' )
			// org/apiwatch/analyser/c/C.g:778:22: 'switch'
			{
			match("switch"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SWITCH"

	// $ANTLR start "TYPEDEF"
	public final void mTYPEDEF() throws RecognitionException {
		try {
			int _type = TYPEDEF;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:779:20: ( 'typedef' )
			// org/apiwatch/analyser/c/C.g:779:22: 'typedef'
			{
			match("typedef"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "TYPEDEF"

	// $ANTLR start "UNION"
	public final void mUNION() throws RecognitionException {
		try {
			int _type = UNION;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:780:20: ( 'union' )
			// org/apiwatch/analyser/c/C.g:780:22: 'union'
			{
			match("union"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "UNION"

	// $ANTLR start "UNSIGNED"
	public final void mUNSIGNED() throws RecognitionException {
		try {
			int _type = UNSIGNED;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:781:20: ( 'unsigned' )
			// org/apiwatch/analyser/c/C.g:781:22: 'unsigned'
			{
			match("unsigned"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "UNSIGNED"

	// $ANTLR start "VOID"
	public final void mVOID() throws RecognitionException {
		try {
			int _type = VOID;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:782:20: ( 'void' )
			// org/apiwatch/analyser/c/C.g:782:22: 'void'
			{
			match("void"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "VOID"

	// $ANTLR start "VOLATILE"
	public final void mVOLATILE() throws RecognitionException {
		try {
			int _type = VOLATILE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:783:20: ( 'volatile' | '__volatile__' )
			int alt5=2;
			int LA5_0 = input.LA(1);
			if ( (LA5_0=='v') ) {
				alt5=1;
			}
			else if ( (LA5_0=='_') ) {
				alt5=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 5, 0, input);
				throw nvae;
			}

			switch (alt5) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:783:22: 'volatile'
					{
					match("volatile"); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:783:33: '__volatile__'
					{
					match("__volatile__"); 

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "VOLATILE"

	// $ANTLR start "WHILE"
	public final void mWHILE() throws RecognitionException {
		try {
			int _type = WHILE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:784:20: ( 'while' )
			// org/apiwatch/analyser/c/C.g:784:22: 'while'
			{
			match("while"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "WHILE"

	// $ANTLR start "IDENTIFIER"
	public final void mIDENTIFIER() throws RecognitionException {
		try {
			int _type = IDENTIFIER;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:788:3: ( LETTER ( LETTER | '0' .. '9' )* )
			// org/apiwatch/analyser/c/C.g:788:5: LETTER ( LETTER | '0' .. '9' )*
			{
			mLETTER(); 

			// org/apiwatch/analyser/c/C.g:788:12: ( LETTER | '0' .. '9' )*
			loop6:
			while (true) {
				int alt6=2;
				int LA6_0 = input.LA(1);
				if ( (LA6_0=='$'||(LA6_0 >= '0' && LA6_0 <= '9')||(LA6_0 >= 'A' && LA6_0 <= 'Z')||LA6_0=='_'||(LA6_0 >= 'a' && LA6_0 <= 'z')) ) {
					alt6=1;
				}

				switch (alt6) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( input.LA(1)=='$'||(input.LA(1) >= '0' && input.LA(1) <= '9')||(input.LA(1) >= 'A' && input.LA(1) <= 'Z')||input.LA(1)=='_'||(input.LA(1) >= 'a' && input.LA(1) <= 'z') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					break loop6;
				}
			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "IDENTIFIER"

	// $ANTLR start "LETTER"
	public final void mLETTER() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:794:3: ( '$' | 'A' .. 'Z' | 'a' .. 'z' | '_' )
			// org/apiwatch/analyser/c/C.g:
			{
			if ( input.LA(1)=='$'||(input.LA(1) >= 'A' && input.LA(1) <= 'Z')||input.LA(1)=='_'||(input.LA(1) >= 'a' && input.LA(1) <= 'z') ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LETTER"

	// $ANTLR start "CHARACTER_LITERAL"
	public final void mCHARACTER_LITERAL() throws RecognitionException {
		try {
			int _type = CHARACTER_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:800:3: ( '\\'' ( EscapeSequence |~ ( '\\'' | '\\\\' ) ) '\\'' )
			// org/apiwatch/analyser/c/C.g:800:5: '\\'' ( EscapeSequence |~ ( '\\'' | '\\\\' ) ) '\\''
			{
			match('\''); 
			// org/apiwatch/analyser/c/C.g:800:10: ( EscapeSequence |~ ( '\\'' | '\\\\' ) )
			int alt7=2;
			int LA7_0 = input.LA(1);
			if ( (LA7_0=='\\') ) {
				alt7=1;
			}
			else if ( ((LA7_0 >= '\u0000' && LA7_0 <= '&')||(LA7_0 >= '(' && LA7_0 <= '[')||(LA7_0 >= ']' && LA7_0 <= '\uFFFF')) ) {
				alt7=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 7, 0, input);
				throw nvae;
			}

			switch (alt7) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:800:12: EscapeSequence
					{
					mEscapeSequence(); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:800:29: ~ ( '\\'' | '\\\\' )
					{
					if ( (input.LA(1) >= '\u0000' && input.LA(1) <= '&')||(input.LA(1) >= '(' && input.LA(1) <= '[')||(input.LA(1) >= ']' && input.LA(1) <= '\uFFFF') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

			}

			match('\''); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CHARACTER_LITERAL"

	// $ANTLR start "STRING_LITERAL"
	public final void mSTRING_LITERAL() throws RecognitionException {
		try {
			int _type = STRING_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:804:3: ( '\"' ( EscapeSequence |~ ( '\\\\' | '\"' ) )* '\"' )
			// org/apiwatch/analyser/c/C.g:804:5: '\"' ( EscapeSequence |~ ( '\\\\' | '\"' ) )* '\"'
			{
			match('\"'); 
			// org/apiwatch/analyser/c/C.g:804:9: ( EscapeSequence |~ ( '\\\\' | '\"' ) )*
			loop8:
			while (true) {
				int alt8=3;
				int LA8_0 = input.LA(1);
				if ( (LA8_0=='\\') ) {
					alt8=1;
				}
				else if ( ((LA8_0 >= '\u0000' && LA8_0 <= '!')||(LA8_0 >= '#' && LA8_0 <= '[')||(LA8_0 >= ']' && LA8_0 <= '\uFFFF')) ) {
					alt8=2;
				}

				switch (alt8) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:804:11: EscapeSequence
					{
					mEscapeSequence(); 

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:804:28: ~ ( '\\\\' | '\"' )
					{
					if ( (input.LA(1) >= '\u0000' && input.LA(1) <= '!')||(input.LA(1) >= '#' && input.LA(1) <= '[')||(input.LA(1) >= ']' && input.LA(1) <= '\uFFFF') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					break loop8;
				}
			}

			match('\"'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STRING_LITERAL"

	// $ANTLR start "HEX_LITERAL"
	public final void mHEX_LITERAL() throws RecognitionException {
		try {
			int _type = HEX_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:808:3: ( '0' ( 'x' | 'X' ) ( HexDigit )+ ( IntegerTypeSuffix )? )
			// org/apiwatch/analyser/c/C.g:808:5: '0' ( 'x' | 'X' ) ( HexDigit )+ ( IntegerTypeSuffix )?
			{
			match('0'); 
			if ( input.LA(1)=='X'||input.LA(1)=='x' ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			// org/apiwatch/analyser/c/C.g:808:19: ( HexDigit )+
			int cnt9=0;
			loop9:
			while (true) {
				int alt9=2;
				int LA9_0 = input.LA(1);
				if ( ((LA9_0 >= '0' && LA9_0 <= '9')||(LA9_0 >= 'A' && LA9_0 <= 'F')||(LA9_0 >= 'a' && LA9_0 <= 'f')) ) {
					alt9=1;
				}

				switch (alt9) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '0' && input.LA(1) <= '9')||(input.LA(1) >= 'A' && input.LA(1) <= 'F')||(input.LA(1) >= 'a' && input.LA(1) <= 'f') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					if ( cnt9 >= 1 ) break loop9;
					EarlyExitException eee = new EarlyExitException(9, input);
					throw eee;
				}
				cnt9++;
			}

			// org/apiwatch/analyser/c/C.g:808:29: ( IntegerTypeSuffix )?
			int alt10=2;
			int LA10_0 = input.LA(1);
			if ( (LA10_0=='L'||LA10_0=='U'||LA10_0=='l'||LA10_0=='u') ) {
				alt10=1;
			}
			switch (alt10) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:808:29: IntegerTypeSuffix
					{
					mIntegerTypeSuffix(); 

					}
					break;

			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "HEX_LITERAL"

	// $ANTLR start "DECIMAL_LITERAL"
	public final void mDECIMAL_LITERAL() throws RecognitionException {
		try {
			int _type = DECIMAL_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:812:3: ( ( '0' | '1' .. '9' ( '0' .. '9' )* ) ( IntegerTypeSuffix )? )
			// org/apiwatch/analyser/c/C.g:812:5: ( '0' | '1' .. '9' ( '0' .. '9' )* ) ( IntegerTypeSuffix )?
			{
			// org/apiwatch/analyser/c/C.g:812:5: ( '0' | '1' .. '9' ( '0' .. '9' )* )
			int alt12=2;
			int LA12_0 = input.LA(1);
			if ( (LA12_0=='0') ) {
				alt12=1;
			}
			else if ( ((LA12_0 >= '1' && LA12_0 <= '9')) ) {
				alt12=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 12, 0, input);
				throw nvae;
			}

			switch (alt12) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:812:6: '0'
					{
					match('0'); 
					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:812:12: '1' .. '9' ( '0' .. '9' )*
					{
					matchRange('1','9'); 
					// org/apiwatch/analyser/c/C.g:812:21: ( '0' .. '9' )*
					loop11:
					while (true) {
						int alt11=2;
						int LA11_0 = input.LA(1);
						if ( ((LA11_0 >= '0' && LA11_0 <= '9')) ) {
							alt11=1;
						}

						switch (alt11) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							break loop11;
						}
					}

					}
					break;

			}

			// org/apiwatch/analyser/c/C.g:812:32: ( IntegerTypeSuffix )?
			int alt13=2;
			int LA13_0 = input.LA(1);
			if ( (LA13_0=='L'||LA13_0=='U'||LA13_0=='l'||LA13_0=='u') ) {
				alt13=1;
			}
			switch (alt13) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:812:32: IntegerTypeSuffix
					{
					mIntegerTypeSuffix(); 

					}
					break;

			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DECIMAL_LITERAL"

	// $ANTLR start "OCTAL_LITERAL"
	public final void mOCTAL_LITERAL() throws RecognitionException {
		try {
			int _type = OCTAL_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:816:3: ( '0' ( '0' .. '7' )+ ( IntegerTypeSuffix )? )
			// org/apiwatch/analyser/c/C.g:816:5: '0' ( '0' .. '7' )+ ( IntegerTypeSuffix )?
			{
			match('0'); 
			// org/apiwatch/analyser/c/C.g:816:9: ( '0' .. '7' )+
			int cnt14=0;
			loop14:
			while (true) {
				int alt14=2;
				int LA14_0 = input.LA(1);
				if ( ((LA14_0 >= '0' && LA14_0 <= '7')) ) {
					alt14=1;
				}

				switch (alt14) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					if ( cnt14 >= 1 ) break loop14;
					EarlyExitException eee = new EarlyExitException(14, input);
					throw eee;
				}
				cnt14++;
			}

			// org/apiwatch/analyser/c/C.g:816:21: ( IntegerTypeSuffix )?
			int alt15=2;
			int LA15_0 = input.LA(1);
			if ( (LA15_0=='L'||LA15_0=='U'||LA15_0=='l'||LA15_0=='u') ) {
				alt15=1;
			}
			switch (alt15) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:816:21: IntegerTypeSuffix
					{
					mIntegerTypeSuffix(); 

					}
					break;

			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "OCTAL_LITERAL"

	// $ANTLR start "HexDigit"
	public final void mHexDigit() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:822:3: ( ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' ) )
			// org/apiwatch/analyser/c/C.g:
			{
			if ( (input.LA(1) >= '0' && input.LA(1) <= '9')||(input.LA(1) >= 'A' && input.LA(1) <= 'F')||(input.LA(1) >= 'a' && input.LA(1) <= 'f') ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "HexDigit"

	// $ANTLR start "IntegerTypeSuffix"
	public final void mIntegerTypeSuffix() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:827:3: ( ( 'u' | 'U' ) ( 'l' | 'L' ) | ( 'u' | 'U' ) | ( 'l' | 'L' ) ( 'l' | 'L' )? )
			int alt17=3;
			int LA17_0 = input.LA(1);
			if ( (LA17_0=='U'||LA17_0=='u') ) {
				int LA17_1 = input.LA(2);
				if ( (LA17_1=='L'||LA17_1=='l') ) {
					alt17=1;
				}

				else {
					alt17=2;
				}

			}
			else if ( (LA17_0=='L'||LA17_0=='l') ) {
				alt17=3;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 17, 0, input);
				throw nvae;
			}

			switch (alt17) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:827:5: ( 'u' | 'U' ) ( 'l' | 'L' )
					{
					if ( input.LA(1)=='U'||input.LA(1)=='u' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					if ( input.LA(1)=='L'||input.LA(1)=='l' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:828:5: ( 'u' | 'U' )
					{
					if ( input.LA(1)=='U'||input.LA(1)=='u' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:829:5: ( 'l' | 'L' ) ( 'l' | 'L' )?
					{
					if ( input.LA(1)=='L'||input.LA(1)=='l' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					// org/apiwatch/analyser/c/C.g:829:15: ( 'l' | 'L' )?
					int alt16=2;
					int LA16_0 = input.LA(1);
					if ( (LA16_0=='L'||LA16_0=='l') ) {
						alt16=1;
					}
					switch (alt16) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( input.LA(1)=='L'||input.LA(1)=='l' ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

					}

					}
					break;

			}
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "IntegerTypeSuffix"

	// $ANTLR start "FLOATING_POINT_LITERAL"
	public final void mFLOATING_POINT_LITERAL() throws RecognitionException {
		try {
			int _type = FLOATING_POINT_LITERAL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:832:3: ( ( '0' .. '9' )+ DOT ( '0' .. '9' )* ( Exponent )? ( FloatTypeSuffix )? | DOT ( '0' .. '9' )+ ( Exponent )? ( FloatTypeSuffix )? | ( '0' .. '9' )+ Exponent FloatTypeSuffix | ( '0' .. '9' )+ Exponent | ( '0' .. '9' )+ FloatTypeSuffix )
			int alt28=5;
			alt28 = dfa28.predict(input);
			switch (alt28) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:832:5: ( '0' .. '9' )+ DOT ( '0' .. '9' )* ( Exponent )? ( FloatTypeSuffix )?
					{
					// org/apiwatch/analyser/c/C.g:832:5: ( '0' .. '9' )+
					int cnt18=0;
					loop18:
					while (true) {
						int alt18=2;
						int LA18_0 = input.LA(1);
						if ( ((LA18_0 >= '0' && LA18_0 <= '9')) ) {
							alt18=1;
						}

						switch (alt18) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							if ( cnt18 >= 1 ) break loop18;
							EarlyExitException eee = new EarlyExitException(18, input);
							throw eee;
						}
						cnt18++;
					}

					mDOT(); 

					// org/apiwatch/analyser/c/C.g:832:21: ( '0' .. '9' )*
					loop19:
					while (true) {
						int alt19=2;
						int LA19_0 = input.LA(1);
						if ( ((LA19_0 >= '0' && LA19_0 <= '9')) ) {
							alt19=1;
						}

						switch (alt19) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							break loop19;
						}
					}

					// org/apiwatch/analyser/c/C.g:832:33: ( Exponent )?
					int alt20=2;
					int LA20_0 = input.LA(1);
					if ( (LA20_0=='E'||LA20_0=='e') ) {
						alt20=1;
					}
					switch (alt20) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:832:33: Exponent
							{
							mExponent(); 

							}
							break;

					}

					// org/apiwatch/analyser/c/C.g:832:43: ( FloatTypeSuffix )?
					int alt21=2;
					int LA21_0 = input.LA(1);
					if ( (LA21_0=='D'||LA21_0=='F'||LA21_0=='d'||LA21_0=='f') ) {
						alt21=1;
					}
					switch (alt21) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( input.LA(1)=='D'||input.LA(1)=='F'||input.LA(1)=='d'||input.LA(1)=='f' ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

					}

					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:833:5: DOT ( '0' .. '9' )+ ( Exponent )? ( FloatTypeSuffix )?
					{
					mDOT(); 

					// org/apiwatch/analyser/c/C.g:833:9: ( '0' .. '9' )+
					int cnt22=0;
					loop22:
					while (true) {
						int alt22=2;
						int LA22_0 = input.LA(1);
						if ( ((LA22_0 >= '0' && LA22_0 <= '9')) ) {
							alt22=1;
						}

						switch (alt22) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							if ( cnt22 >= 1 ) break loop22;
							EarlyExitException eee = new EarlyExitException(22, input);
							throw eee;
						}
						cnt22++;
					}

					// org/apiwatch/analyser/c/C.g:833:21: ( Exponent )?
					int alt23=2;
					int LA23_0 = input.LA(1);
					if ( (LA23_0=='E'||LA23_0=='e') ) {
						alt23=1;
					}
					switch (alt23) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:833:21: Exponent
							{
							mExponent(); 

							}
							break;

					}

					// org/apiwatch/analyser/c/C.g:833:31: ( FloatTypeSuffix )?
					int alt24=2;
					int LA24_0 = input.LA(1);
					if ( (LA24_0=='D'||LA24_0=='F'||LA24_0=='d'||LA24_0=='f') ) {
						alt24=1;
					}
					switch (alt24) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( input.LA(1)=='D'||input.LA(1)=='F'||input.LA(1)=='d'||input.LA(1)=='f' ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

					}

					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:834:5: ( '0' .. '9' )+ Exponent FloatTypeSuffix
					{
					// org/apiwatch/analyser/c/C.g:834:5: ( '0' .. '9' )+
					int cnt25=0;
					loop25:
					while (true) {
						int alt25=2;
						int LA25_0 = input.LA(1);
						if ( ((LA25_0 >= '0' && LA25_0 <= '9')) ) {
							alt25=1;
						}

						switch (alt25) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							if ( cnt25 >= 1 ) break loop25;
							EarlyExitException eee = new EarlyExitException(25, input);
							throw eee;
						}
						cnt25++;
					}

					mExponent(); 

					mFloatTypeSuffix(); 

					}
					break;
				case 4 :
					// org/apiwatch/analyser/c/C.g:835:5: ( '0' .. '9' )+ Exponent
					{
					// org/apiwatch/analyser/c/C.g:835:5: ( '0' .. '9' )+
					int cnt26=0;
					loop26:
					while (true) {
						int alt26=2;
						int LA26_0 = input.LA(1);
						if ( ((LA26_0 >= '0' && LA26_0 <= '9')) ) {
							alt26=1;
						}

						switch (alt26) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							if ( cnt26 >= 1 ) break loop26;
							EarlyExitException eee = new EarlyExitException(26, input);
							throw eee;
						}
						cnt26++;
					}

					mExponent(); 

					}
					break;
				case 5 :
					// org/apiwatch/analyser/c/C.g:836:5: ( '0' .. '9' )+ FloatTypeSuffix
					{
					// org/apiwatch/analyser/c/C.g:836:5: ( '0' .. '9' )+
					int cnt27=0;
					loop27:
					while (true) {
						int alt27=2;
						int LA27_0 = input.LA(1);
						if ( ((LA27_0 >= '0' && LA27_0 <= '9')) ) {
							alt27=1;
						}

						switch (alt27) {
						case 1 :
							// org/apiwatch/analyser/c/C.g:
							{
							if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							if ( cnt27 >= 1 ) break loop27;
							EarlyExitException eee = new EarlyExitException(27, input);
							throw eee;
						}
						cnt27++;
					}

					mFloatTypeSuffix(); 

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FLOATING_POINT_LITERAL"

	// $ANTLR start "Exponent"
	public final void mExponent() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:842:3: ( ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+ )
			// org/apiwatch/analyser/c/C.g:842:5: ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+
			{
			if ( input.LA(1)=='E'||input.LA(1)=='e' ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			// org/apiwatch/analyser/c/C.g:842:15: ( '+' | '-' )?
			int alt29=2;
			int LA29_0 = input.LA(1);
			if ( (LA29_0=='+'||LA29_0=='-') ) {
				alt29=1;
			}
			switch (alt29) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( input.LA(1)=='+'||input.LA(1)=='-' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

			}

			// org/apiwatch/analyser/c/C.g:842:26: ( '0' .. '9' )+
			int cnt30=0;
			loop30:
			while (true) {
				int alt30=2;
				int LA30_0 = input.LA(1);
				if ( ((LA30_0 >= '0' && LA30_0 <= '9')) ) {
					alt30=1;
				}

				switch (alt30) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					if ( cnt30 >= 1 ) break loop30;
					EarlyExitException eee = new EarlyExitException(30, input);
					throw eee;
				}
				cnt30++;
			}

			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "Exponent"

	// $ANTLR start "FloatTypeSuffix"
	public final void mFloatTypeSuffix() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:847:3: ( ( 'f' | 'F' | 'd' | 'D' ) )
			// org/apiwatch/analyser/c/C.g:
			{
			if ( input.LA(1)=='D'||input.LA(1)=='F'||input.LA(1)=='d'||input.LA(1)=='f' ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FloatTypeSuffix"

	// $ANTLR start "EscapeSequence"
	public final void mEscapeSequence() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:852:3: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' ) | OctalEscape )
			int alt31=2;
			int LA31_0 = input.LA(1);
			if ( (LA31_0=='\\') ) {
				int LA31_1 = input.LA(2);
				if ( (LA31_1=='\"'||LA31_1=='\''||LA31_1=='\\'||LA31_1=='b'||LA31_1=='f'||LA31_1=='n'||LA31_1=='r'||LA31_1=='t') ) {
					alt31=1;
				}
				else if ( ((LA31_1 >= '0' && LA31_1 <= '7')) ) {
					alt31=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 31, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 31, 0, input);
				throw nvae;
			}

			switch (alt31) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:852:5: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' )
					{
					match('\\'); 
					if ( input.LA(1)=='\"'||input.LA(1)=='\''||input.LA(1)=='\\'||input.LA(1)=='b'||input.LA(1)=='f'||input.LA(1)=='n'||input.LA(1)=='r'||input.LA(1)=='t' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:853:5: OctalEscape
					{
					mOctalEscape(); 

					}
					break;

			}
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "EscapeSequence"

	// $ANTLR start "OctalEscape"
	public final void mOctalEscape() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:858:3: ( '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) )
			int alt32=3;
			int LA32_0 = input.LA(1);
			if ( (LA32_0=='\\') ) {
				int LA32_1 = input.LA(2);
				if ( ((LA32_1 >= '0' && LA32_1 <= '3')) ) {
					int LA32_2 = input.LA(3);
					if ( ((LA32_2 >= '0' && LA32_2 <= '7')) ) {
						int LA32_4 = input.LA(4);
						if ( ((LA32_4 >= '0' && LA32_4 <= '7')) ) {
							alt32=1;
						}

						else {
							alt32=2;
						}

					}

					else {
						alt32=3;
					}

				}
				else if ( ((LA32_1 >= '4' && LA32_1 <= '7')) ) {
					int LA32_3 = input.LA(3);
					if ( ((LA32_3 >= '0' && LA32_3 <= '7')) ) {
						alt32=2;
					}

					else {
						alt32=3;
					}

				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 32, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 32, 0, input);
				throw nvae;
			}

			switch (alt32) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:858:5: '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' )
					{
					match('\\'); 
					if ( (input.LA(1) >= '0' && input.LA(1) <= '3') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;
				case 2 :
					// org/apiwatch/analyser/c/C.g:859:5: '\\\\' ( '0' .. '7' ) ( '0' .. '7' )
					{
					match('\\'); 
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;
				case 3 :
					// org/apiwatch/analyser/c/C.g:860:5: '\\\\' ( '0' .. '7' )
					{
					match('\\'); 
					if ( (input.LA(1) >= '0' && input.LA(1) <= '7') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

			}
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "OctalEscape"

	// $ANTLR start "UnicodeEscape"
	public final void mUnicodeEscape() throws RecognitionException {
		try {
			// org/apiwatch/analyser/c/C.g:865:3: ( '\\\\' 'u' HexDigit HexDigit HexDigit HexDigit )
			// org/apiwatch/analyser/c/C.g:865:5: '\\\\' 'u' HexDigit HexDigit HexDigit HexDigit
			{
			match('\\'); 
			match('u'); 
			mHexDigit(); 

			mHexDigit(); 

			mHexDigit(); 

			mHexDigit(); 

			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "UnicodeEscape"

	// $ANTLR start "WS"
	public final void mWS() throws RecognitionException {
		try {
			int _type = WS;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:867:3: ( ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+ )
			// org/apiwatch/analyser/c/C.g:867:5: ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+
			{
			// org/apiwatch/analyser/c/C.g:867:5: ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+
			int cnt33=0;
			loop33:
			while (true) {
				int alt33=2;
				int LA33_0 = input.LA(1);
				if ( ((LA33_0 >= '\t' && LA33_0 <= '\n')||(LA33_0 >= '\f' && LA33_0 <= '\r')||LA33_0==' ') ) {
					alt33=1;
				}

				switch (alt33) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '\t' && input.LA(1) <= '\n')||(input.LA(1) >= '\f' && input.LA(1) <= '\r')||input.LA(1)==' ' ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					if ( cnt33 >= 1 ) break loop33;
					EarlyExitException eee = new EarlyExitException(33, input);
					throw eee;
				}
				cnt33++;
			}

			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "WS"

	// $ANTLR start "COMMENT"
	public final void mCOMMENT() throws RecognitionException {
		try {
			int _type = COMMENT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:871:3: ( '/*' ( options {greedy=false; } : . )* '*/' )
			// org/apiwatch/analyser/c/C.g:871:5: '/*' ( options {greedy=false; } : . )* '*/'
			{
			match("/*"); 

			// org/apiwatch/analyser/c/C.g:871:10: ( options {greedy=false; } : . )*
			loop34:
			while (true) {
				int alt34=2;
				int LA34_0 = input.LA(1);
				if ( (LA34_0=='*') ) {
					int LA34_1 = input.LA(2);
					if ( (LA34_1=='/') ) {
						alt34=2;
					}
					else if ( ((LA34_1 >= '\u0000' && LA34_1 <= '.')||(LA34_1 >= '0' && LA34_1 <= '\uFFFF')) ) {
						alt34=1;
					}

				}
				else if ( ((LA34_0 >= '\u0000' && LA34_0 <= ')')||(LA34_0 >= '+' && LA34_0 <= '\uFFFF')) ) {
					alt34=1;
				}

				switch (alt34) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:871:38: .
					{
					matchAny(); 
					}
					break;

				default :
					break loop34;
				}
			}

			match("*/"); 

			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "COMMENT"

	// $ANTLR start "LINE_COMMENT"
	public final void mLINE_COMMENT() throws RecognitionException {
		try {
			int _type = LINE_COMMENT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:875:3: ( '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n' )
			// org/apiwatch/analyser/c/C.g:875:5: '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n'
			{
			match("//"); 

			// org/apiwatch/analyser/c/C.g:875:10: (~ ( '\\n' | '\\r' ) )*
			loop35:
			while (true) {
				int alt35=2;
				int LA35_0 = input.LA(1);
				if ( ((LA35_0 >= '\u0000' && LA35_0 <= '\t')||(LA35_0 >= '\u000B' && LA35_0 <= '\f')||(LA35_0 >= '\u000E' && LA35_0 <= '\uFFFF')) ) {
					alt35=1;
				}

				switch (alt35) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '\u0000' && input.LA(1) <= '\t')||(input.LA(1) >= '\u000B' && input.LA(1) <= '\f')||(input.LA(1) >= '\u000E' && input.LA(1) <= '\uFFFF') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					break loop35;
				}
			}

			// org/apiwatch/analyser/c/C.g:875:24: ( '\\r' )?
			int alt36=2;
			int LA36_0 = input.LA(1);
			if ( (LA36_0=='\r') ) {
				alt36=1;
			}
			switch (alt36) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:875:24: '\\r'
					{
					match('\r'); 
					}
					break;

			}

			match('\n'); 
			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LINE_COMMENT"

	// $ANTLR start "PREPROCESSOR_COMMAND"
	public final void mPREPROCESSOR_COMMAND() throws RecognitionException {
		try {
			int _type = PREPROCESSOR_COMMAND;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// org/apiwatch/analyser/c/C.g:879:3: ( '#' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n' )
			// org/apiwatch/analyser/c/C.g:879:5: '#' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n'
			{
			match('#'); 
			// org/apiwatch/analyser/c/C.g:879:9: (~ ( '\\n' | '\\r' ) )*
			loop37:
			while (true) {
				int alt37=2;
				int LA37_0 = input.LA(1);
				if ( ((LA37_0 >= '\u0000' && LA37_0 <= '\t')||(LA37_0 >= '\u000B' && LA37_0 <= '\f')||(LA37_0 >= '\u000E' && LA37_0 <= '\uFFFF')) ) {
					alt37=1;
				}

				switch (alt37) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:
					{
					if ( (input.LA(1) >= '\u0000' && input.LA(1) <= '\t')||(input.LA(1) >= '\u000B' && input.LA(1) <= '\f')||(input.LA(1) >= '\u000E' && input.LA(1) <= '\uFFFF') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					break loop37;
				}
			}

			// org/apiwatch/analyser/c/C.g:879:23: ( '\\r' )?
			int alt38=2;
			int LA38_0 = input.LA(1);
			if ( (LA38_0=='\r') ) {
				alt38=1;
			}
			switch (alt38) {
				case 1 :
					// org/apiwatch/analyser/c/C.g:879:23: '\\r'
					{
					match('\r'); 
					}
					break;

			}

			match('\n'); 
			_channel=HIDDEN; recordHeader(state.tokenStartLine, getText());
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "PREPROCESSOR_COMMAND"

	@Override
	public void mTokens() throws RecognitionException {
		// org/apiwatch/analyser/c/C.g:1:8: ( AND | AND_ASSIGN | ASSIGN | ARROW | COLON | COMMA | DECR | DIV | DIV_ASSIGN | DOT | ELLIPSIS | EQUAL | GREATER_OR_EQUAL | GREATER_THAN | INCR | LBRACK | LCURLY | LESS_OR_EQUAL | LESS_THAN | LOGICAL_AND | LOGICAL_NOT | LOGICAL_OR | LPAREN | MINUS | MINUS_ASSIGN | MOD | MOD_ASSIGN | NOT | NOT_EQUAL | OR | OR_ASSIGN | PLUS | PLUS_ASSIGN | QUESTION | RBRACK | RCURLY | RPAREN | SEMI | SHIFT_LEFT | SHIFT_LEFT_ASSIGN | SHIFT_RIGHT | SHIFT_RIGHT_ASSIGN | STAR | STAR_ASSIGN | XOR | XOR_ASSIGN | ASM | AUTO | BREAK | CASE | CHAR | CONST | CONTINUE | DEFAULT | DECLSPEC | DO | DOUBLE | ELSE | ENUM | EXTERN | EXTENSION | FLOAT | FOR | ATTRIBUTE | GOTO | IF | INT | INLINE | LONG | REGISTER | RESTRICT | RETURN | SHORT | SIGNED | SIZEOF | STATIC | STRUCT | SWITCH | TYPEDEF | UNION | UNSIGNED | VOID | VOLATILE | WHILE | IDENTIFIER | CHARACTER_LITERAL | STRING_LITERAL | HEX_LITERAL | DECIMAL_LITERAL | OCTAL_LITERAL | FLOATING_POINT_LITERAL | WS | COMMENT | LINE_COMMENT | PREPROCESSOR_COMMAND )
		int alt39=95;
		alt39 = dfa39.predict(input);
		switch (alt39) {
			case 1 :
				// org/apiwatch/analyser/c/C.g:1:10: AND
				{
				mAND(); 

				}
				break;
			case 2 :
				// org/apiwatch/analyser/c/C.g:1:14: AND_ASSIGN
				{
				mAND_ASSIGN(); 

				}
				break;
			case 3 :
				// org/apiwatch/analyser/c/C.g:1:25: ASSIGN
				{
				mASSIGN(); 

				}
				break;
			case 4 :
				// org/apiwatch/analyser/c/C.g:1:32: ARROW
				{
				mARROW(); 

				}
				break;
			case 5 :
				// org/apiwatch/analyser/c/C.g:1:38: COLON
				{
				mCOLON(); 

				}
				break;
			case 6 :
				// org/apiwatch/analyser/c/C.g:1:44: COMMA
				{
				mCOMMA(); 

				}
				break;
			case 7 :
				// org/apiwatch/analyser/c/C.g:1:50: DECR
				{
				mDECR(); 

				}
				break;
			case 8 :
				// org/apiwatch/analyser/c/C.g:1:55: DIV
				{
				mDIV(); 

				}
				break;
			case 9 :
				// org/apiwatch/analyser/c/C.g:1:59: DIV_ASSIGN
				{
				mDIV_ASSIGN(); 

				}
				break;
			case 10 :
				// org/apiwatch/analyser/c/C.g:1:70: DOT
				{
				mDOT(); 

				}
				break;
			case 11 :
				// org/apiwatch/analyser/c/C.g:1:74: ELLIPSIS
				{
				mELLIPSIS(); 

				}
				break;
			case 12 :
				// org/apiwatch/analyser/c/C.g:1:83: EQUAL
				{
				mEQUAL(); 

				}
				break;
			case 13 :
				// org/apiwatch/analyser/c/C.g:1:89: GREATER_OR_EQUAL
				{
				mGREATER_OR_EQUAL(); 

				}
				break;
			case 14 :
				// org/apiwatch/analyser/c/C.g:1:106: GREATER_THAN
				{
				mGREATER_THAN(); 

				}
				break;
			case 15 :
				// org/apiwatch/analyser/c/C.g:1:119: INCR
				{
				mINCR(); 

				}
				break;
			case 16 :
				// org/apiwatch/analyser/c/C.g:1:124: LBRACK
				{
				mLBRACK(); 

				}
				break;
			case 17 :
				// org/apiwatch/analyser/c/C.g:1:131: LCURLY
				{
				mLCURLY(); 

				}
				break;
			case 18 :
				// org/apiwatch/analyser/c/C.g:1:138: LESS_OR_EQUAL
				{
				mLESS_OR_EQUAL(); 

				}
				break;
			case 19 :
				// org/apiwatch/analyser/c/C.g:1:152: LESS_THAN
				{
				mLESS_THAN(); 

				}
				break;
			case 20 :
				// org/apiwatch/analyser/c/C.g:1:162: LOGICAL_AND
				{
				mLOGICAL_AND(); 

				}
				break;
			case 21 :
				// org/apiwatch/analyser/c/C.g:1:174: LOGICAL_NOT
				{
				mLOGICAL_NOT(); 

				}
				break;
			case 22 :
				// org/apiwatch/analyser/c/C.g:1:186: LOGICAL_OR
				{
				mLOGICAL_OR(); 

				}
				break;
			case 23 :
				// org/apiwatch/analyser/c/C.g:1:197: LPAREN
				{
				mLPAREN(); 

				}
				break;
			case 24 :
				// org/apiwatch/analyser/c/C.g:1:204: MINUS
				{
				mMINUS(); 

				}
				break;
			case 25 :
				// org/apiwatch/analyser/c/C.g:1:210: MINUS_ASSIGN
				{
				mMINUS_ASSIGN(); 

				}
				break;
			case 26 :
				// org/apiwatch/analyser/c/C.g:1:223: MOD
				{
				mMOD(); 

				}
				break;
			case 27 :
				// org/apiwatch/analyser/c/C.g:1:227: MOD_ASSIGN
				{
				mMOD_ASSIGN(); 

				}
				break;
			case 28 :
				// org/apiwatch/analyser/c/C.g:1:238: NOT
				{
				mNOT(); 

				}
				break;
			case 29 :
				// org/apiwatch/analyser/c/C.g:1:242: NOT_EQUAL
				{
				mNOT_EQUAL(); 

				}
				break;
			case 30 :
				// org/apiwatch/analyser/c/C.g:1:252: OR
				{
				mOR(); 

				}
				break;
			case 31 :
				// org/apiwatch/analyser/c/C.g:1:255: OR_ASSIGN
				{
				mOR_ASSIGN(); 

				}
				break;
			case 32 :
				// org/apiwatch/analyser/c/C.g:1:265: PLUS
				{
				mPLUS(); 

				}
				break;
			case 33 :
				// org/apiwatch/analyser/c/C.g:1:270: PLUS_ASSIGN
				{
				mPLUS_ASSIGN(); 

				}
				break;
			case 34 :
				// org/apiwatch/analyser/c/C.g:1:282: QUESTION
				{
				mQUESTION(); 

				}
				break;
			case 35 :
				// org/apiwatch/analyser/c/C.g:1:291: RBRACK
				{
				mRBRACK(); 

				}
				break;
			case 36 :
				// org/apiwatch/analyser/c/C.g:1:298: RCURLY
				{
				mRCURLY(); 

				}
				break;
			case 37 :
				// org/apiwatch/analyser/c/C.g:1:305: RPAREN
				{
				mRPAREN(); 

				}
				break;
			case 38 :
				// org/apiwatch/analyser/c/C.g:1:312: SEMI
				{
				mSEMI(); 

				}
				break;
			case 39 :
				// org/apiwatch/analyser/c/C.g:1:317: SHIFT_LEFT
				{
				mSHIFT_LEFT(); 

				}
				break;
			case 40 :
				// org/apiwatch/analyser/c/C.g:1:328: SHIFT_LEFT_ASSIGN
				{
				mSHIFT_LEFT_ASSIGN(); 

				}
				break;
			case 41 :
				// org/apiwatch/analyser/c/C.g:1:346: SHIFT_RIGHT
				{
				mSHIFT_RIGHT(); 

				}
				break;
			case 42 :
				// org/apiwatch/analyser/c/C.g:1:358: SHIFT_RIGHT_ASSIGN
				{
				mSHIFT_RIGHT_ASSIGN(); 

				}
				break;
			case 43 :
				// org/apiwatch/analyser/c/C.g:1:377: STAR
				{
				mSTAR(); 

				}
				break;
			case 44 :
				// org/apiwatch/analyser/c/C.g:1:382: STAR_ASSIGN
				{
				mSTAR_ASSIGN(); 

				}
				break;
			case 45 :
				// org/apiwatch/analyser/c/C.g:1:394: XOR
				{
				mXOR(); 

				}
				break;
			case 46 :
				// org/apiwatch/analyser/c/C.g:1:398: XOR_ASSIGN
				{
				mXOR_ASSIGN(); 

				}
				break;
			case 47 :
				// org/apiwatch/analyser/c/C.g:1:409: ASM
				{
				mASM(); 

				}
				break;
			case 48 :
				// org/apiwatch/analyser/c/C.g:1:413: AUTO
				{
				mAUTO(); 

				}
				break;
			case 49 :
				// org/apiwatch/analyser/c/C.g:1:418: BREAK
				{
				mBREAK(); 

				}
				break;
			case 50 :
				// org/apiwatch/analyser/c/C.g:1:424: CASE
				{
				mCASE(); 

				}
				break;
			case 51 :
				// org/apiwatch/analyser/c/C.g:1:429: CHAR
				{
				mCHAR(); 

				}
				break;
			case 52 :
				// org/apiwatch/analyser/c/C.g:1:434: CONST
				{
				mCONST(); 

				}
				break;
			case 53 :
				// org/apiwatch/analyser/c/C.g:1:440: CONTINUE
				{
				mCONTINUE(); 

				}
				break;
			case 54 :
				// org/apiwatch/analyser/c/C.g:1:449: DEFAULT
				{
				mDEFAULT(); 

				}
				break;
			case 55 :
				// org/apiwatch/analyser/c/C.g:1:457: DECLSPEC
				{
				mDECLSPEC(); 

				}
				break;
			case 56 :
				// org/apiwatch/analyser/c/C.g:1:466: DO
				{
				mDO(); 

				}
				break;
			case 57 :
				// org/apiwatch/analyser/c/C.g:1:469: DOUBLE
				{
				mDOUBLE(); 

				}
				break;
			case 58 :
				// org/apiwatch/analyser/c/C.g:1:476: ELSE
				{
				mELSE(); 

				}
				break;
			case 59 :
				// org/apiwatch/analyser/c/C.g:1:481: ENUM
				{
				mENUM(); 

				}
				break;
			case 60 :
				// org/apiwatch/analyser/c/C.g:1:486: EXTERN
				{
				mEXTERN(); 

				}
				break;
			case 61 :
				// org/apiwatch/analyser/c/C.g:1:493: EXTENSION
				{
				mEXTENSION(); 

				}
				break;
			case 62 :
				// org/apiwatch/analyser/c/C.g:1:503: FLOAT
				{
				mFLOAT(); 

				}
				break;
			case 63 :
				// org/apiwatch/analyser/c/C.g:1:509: FOR
				{
				mFOR(); 

				}
				break;
			case 64 :
				// org/apiwatch/analyser/c/C.g:1:513: ATTRIBUTE
				{
				mATTRIBUTE(); 

				}
				break;
			case 65 :
				// org/apiwatch/analyser/c/C.g:1:523: GOTO
				{
				mGOTO(); 

				}
				break;
			case 66 :
				// org/apiwatch/analyser/c/C.g:1:528: IF
				{
				mIF(); 

				}
				break;
			case 67 :
				// org/apiwatch/analyser/c/C.g:1:531: INT
				{
				mINT(); 

				}
				break;
			case 68 :
				// org/apiwatch/analyser/c/C.g:1:535: INLINE
				{
				mINLINE(); 

				}
				break;
			case 69 :
				// org/apiwatch/analyser/c/C.g:1:542: LONG
				{
				mLONG(); 

				}
				break;
			case 70 :
				// org/apiwatch/analyser/c/C.g:1:547: REGISTER
				{
				mREGISTER(); 

				}
				break;
			case 71 :
				// org/apiwatch/analyser/c/C.g:1:556: RESTRICT
				{
				mRESTRICT(); 

				}
				break;
			case 72 :
				// org/apiwatch/analyser/c/C.g:1:565: RETURN
				{
				mRETURN(); 

				}
				break;
			case 73 :
				// org/apiwatch/analyser/c/C.g:1:572: SHORT
				{
				mSHORT(); 

				}
				break;
			case 74 :
				// org/apiwatch/analyser/c/C.g:1:578: SIGNED
				{
				mSIGNED(); 

				}
				break;
			case 75 :
				// org/apiwatch/analyser/c/C.g:1:585: SIZEOF
				{
				mSIZEOF(); 

				}
				break;
			case 76 :
				// org/apiwatch/analyser/c/C.g:1:592: STATIC
				{
				mSTATIC(); 

				}
				break;
			case 77 :
				// org/apiwatch/analyser/c/C.g:1:599: STRUCT
				{
				mSTRUCT(); 

				}
				break;
			case 78 :
				// org/apiwatch/analyser/c/C.g:1:606: SWITCH
				{
				mSWITCH(); 

				}
				break;
			case 79 :
				// org/apiwatch/analyser/c/C.g:1:613: TYPEDEF
				{
				mTYPEDEF(); 

				}
				break;
			case 80 :
				// org/apiwatch/analyser/c/C.g:1:621: UNION
				{
				mUNION(); 

				}
				break;
			case 81 :
				// org/apiwatch/analyser/c/C.g:1:627: UNSIGNED
				{
				mUNSIGNED(); 

				}
				break;
			case 82 :
				// org/apiwatch/analyser/c/C.g:1:636: VOID
				{
				mVOID(); 

				}
				break;
			case 83 :
				// org/apiwatch/analyser/c/C.g:1:641: VOLATILE
				{
				mVOLATILE(); 

				}
				break;
			case 84 :
				// org/apiwatch/analyser/c/C.g:1:650: WHILE
				{
				mWHILE(); 

				}
				break;
			case 85 :
				// org/apiwatch/analyser/c/C.g:1:656: IDENTIFIER
				{
				mIDENTIFIER(); 

				}
				break;
			case 86 :
				// org/apiwatch/analyser/c/C.g:1:667: CHARACTER_LITERAL
				{
				mCHARACTER_LITERAL(); 

				}
				break;
			case 87 :
				// org/apiwatch/analyser/c/C.g:1:685: STRING_LITERAL
				{
				mSTRING_LITERAL(); 

				}
				break;
			case 88 :
				// org/apiwatch/analyser/c/C.g:1:700: HEX_LITERAL
				{
				mHEX_LITERAL(); 

				}
				break;
			case 89 :
				// org/apiwatch/analyser/c/C.g:1:712: DECIMAL_LITERAL
				{
				mDECIMAL_LITERAL(); 

				}
				break;
			case 90 :
				// org/apiwatch/analyser/c/C.g:1:728: OCTAL_LITERAL
				{
				mOCTAL_LITERAL(); 

				}
				break;
			case 91 :
				// org/apiwatch/analyser/c/C.g:1:742: FLOATING_POINT_LITERAL
				{
				mFLOATING_POINT_LITERAL(); 

				}
				break;
			case 92 :
				// org/apiwatch/analyser/c/C.g:1:765: WS
				{
				mWS(); 

				}
				break;
			case 93 :
				// org/apiwatch/analyser/c/C.g:1:768: COMMENT
				{
				mCOMMENT(); 

				}
				break;
			case 94 :
				// org/apiwatch/analyser/c/C.g:1:776: LINE_COMMENT
				{
				mLINE_COMMENT(); 

				}
				break;
			case 95 :
				// org/apiwatch/analyser/c/C.g:1:789: PREPROCESSOR_COMMAND
				{
				mPREPROCESSOR_COMMAND(); 

				}
				break;

		}
	}


	protected DFA28 dfa28 = new DFA28(this);
	protected DFA39 dfa39 = new DFA39(this);
	static final String DFA28_eotS =
		"\7\uffff\1\10\2\uffff";
	static final String DFA28_eofS =
		"\12\uffff";
	static final String DFA28_minS =
		"\2\56\2\uffff\1\53\1\uffff\2\60\2\uffff";
	static final String DFA28_maxS =
		"\1\71\1\146\2\uffff\1\71\1\uffff\1\71\1\146\2\uffff";
	static final String DFA28_acceptS =
		"\2\uffff\1\2\1\1\1\uffff\1\5\2\uffff\1\4\1\3";
	static final String DFA28_specialS =
		"\12\uffff}>";
	static final String[] DFA28_transitionS = {
			"\1\2\1\uffff\12\1",
			"\1\3\1\uffff\12\1\12\uffff\1\5\1\4\1\5\35\uffff\1\5\1\4\1\5",
			"",
			"",
			"\1\6\1\uffff\1\6\2\uffff\12\7",
			"",
			"\12\7",
			"\12\7\12\uffff\1\11\1\uffff\1\11\35\uffff\1\11\1\uffff\1\11",
			"",
			""
	};

	static final short[] DFA28_eot = DFA.unpackEncodedString(DFA28_eotS);
	static final short[] DFA28_eof = DFA.unpackEncodedString(DFA28_eofS);
	static final char[] DFA28_min = DFA.unpackEncodedStringToUnsignedChars(DFA28_minS);
	static final char[] DFA28_max = DFA.unpackEncodedStringToUnsignedChars(DFA28_maxS);
	static final short[] DFA28_accept = DFA.unpackEncodedString(DFA28_acceptS);
	static final short[] DFA28_special = DFA.unpackEncodedString(DFA28_specialS);
	static final short[][] DFA28_transition;

	static {
		int numStates = DFA28_transitionS.length;
		DFA28_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA28_transition[i] = DFA.unpackEncodedString(DFA28_transitionS[i]);
		}
	}

	protected class DFA28 extends DFA {

		public DFA28(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 28;
			this.eot = DFA28_eot;
			this.eof = DFA28_eof;
			this.min = DFA28_min;
			this.max = DFA28_max;
			this.accept = DFA28_accept;
			this.special = DFA28_special;
			this.transition = DFA28_transition;
		}
		@Override
		public String getDescription() {
			return "831:1: FLOATING_POINT_LITERAL : ( ( '0' .. '9' )+ DOT ( '0' .. '9' )* ( Exponent )? ( FloatTypeSuffix )? | DOT ( '0' .. '9' )+ ( Exponent )? ( FloatTypeSuffix )? | ( '0' .. '9' )+ Exponent FloatTypeSuffix | ( '0' .. '9' )+ Exponent | ( '0' .. '9' )+ FloatTypeSuffix );";
		}
	}

	static final String DFA39_eotS =
		"\1\uffff\1\62\1\64\1\70\2\uffff\1\74\1\76\1\102\1\105\2\uffff\1\110\1"+
		"\112\1\115\1\uffff\1\117\6\uffff\1\121\1\123\20\51\3\uffff\2\160\23\uffff"+
		"\1\164\5\uffff\1\166\14\uffff\10\51\1\u0086\6\51\1\u008d\13\51\2\uffff"+
		"\1\u00a0\1\160\4\uffff\1\u00a1\16\51\1\uffff\4\51\1\u00b6\1\51\1\uffff"+
		"\1\u00b8\21\51\2\uffff\1\u00ca\11\51\1\u00d4\1\u00d5\4\51\1\u00da\1\u00db"+
		"\2\51\1\uffff\1\u00de\1\uffff\1\51\1\u00e0\14\51\1\u00ed\2\51\1\uffff"+
		"\1\u00a1\7\51\1\u00f8\2\uffff\1\u00f9\3\51\2\uffff\1\51\1\u00fe\1\uffff"+
		"\1\51\1\uffff\3\51\1\u0103\6\51\1\u010a\1\51\1\uffff\1\51\1\u010d\10\51"+
		"\2\uffff\2\51\1\u0118\1\u0119\1\uffff\1\u011a\2\51\1\u011d\1\uffff\1\u011e"+
		"\1\u011f\1\u0120\1\u0121\1\u0122\1\51\1\uffff\2\51\1\uffff\1\u00a1\1\51"+
		"\1\u00f9\6\51\1\u012d\3\uffff\2\51\6\uffff\1\u0130\5\51\1\u011a\2\51\1"+
		"\u0139\1\uffff\1\u013a\1\u013b\1\uffff\1\u013c\1\u013d\6\51\5\uffff\1"+
		"\51\1\u0145\1\51\1\u011a\1\u013b\2\51\1\uffff\5\51\1\u013b\1\u013d\1\u014f"+
		"\1\u0150\2\uffff";
	static final String DFA39_eofS =
		"\u0151\uffff";
	static final String DFA39_minS =
		"\1\11\1\46\1\75\1\55\2\uffff\1\52\1\56\1\75\1\53\2\uffff\1\74\2\75\1\uffff"+
		"\1\75\6\uffff\2\75\1\163\1\137\1\162\1\141\1\145\2\154\1\157\1\146\1\157"+
		"\1\145\1\150\1\171\1\156\1\157\1\150\3\uffff\2\56\23\uffff\1\75\5\uffff"+
		"\1\75\14\uffff\1\155\1\164\1\141\1\145\1\163\1\141\1\156\1\146\1\44\1"+
		"\163\1\165\1\164\1\157\1\162\1\164\1\44\1\154\1\156\1\147\1\157\1\147"+
		"\1\141\1\151\1\160\3\151\2\uffff\2\56\4\uffff\1\44\1\157\1\163\1\157\1"+
		"\145\1\170\1\156\1\145\1\157\1\141\1\145\1\162\1\163\1\141\1\142\1\uffff"+
		"\1\145\1\155\1\145\1\141\1\44\1\157\1\uffff\1\44\1\151\1\147\1\151\1\164"+
		"\1\165\1\162\1\156\1\145\1\164\1\165\1\164\1\145\1\157\1\151\1\144\1\141"+
		"\1\154\2\uffff\1\44\1\155\1\164\1\156\1\143\1\164\1\154\1\163\1\154\1"+
		"\153\2\44\1\164\1\151\1\165\1\154\2\44\1\162\1\164\1\uffff\1\44\1\uffff"+
		"\1\156\1\44\1\163\2\162\1\164\1\145\1\157\1\151\2\143\1\144\1\156\1\147"+
		"\1\44\1\164\1\145\1\uffff\1\44\1\162\1\163\1\154\1\145\1\151\1\164\1\141"+
		"\1\44\2\uffff\1\44\1\156\1\154\1\145\2\uffff\1\156\1\44\1\uffff\1\145"+
		"\1\uffff\1\164\1\151\1\156\1\44\1\144\1\146\1\143\1\164\1\150\1\145\1"+
		"\44\1\156\1\uffff\1\151\1\44\1\137\1\151\1\164\1\163\2\156\1\162\1\164"+
		"\2\uffff\1\165\1\164\2\44\1\uffff\1\44\1\145\1\143\1\44\1\uffff\5\44\1"+
		"\146\1\uffff\1\145\1\154\1\uffff\1\44\1\142\1\44\1\160\1\163\1\145\2\151"+
		"\1\145\1\44\3\uffff\1\162\1\164\6\uffff\1\44\1\144\1\145\1\165\1\145\1"+
		"\151\1\44\1\143\1\154\1\44\1\uffff\2\44\1\uffff\2\44\1\164\1\143\1\157"+
		"\1\137\1\164\1\145\5\uffff\1\145\1\44\1\156\2\44\2\137\1\uffff\5\137\4"+
		"\44\2\uffff";
	static final String DFA39_maxS =
		"\1\176\2\75\1\76\2\uffff\1\75\1\71\1\76\1\75\2\uffff\2\75\1\174\1\uffff"+
		"\1\75\6\uffff\2\75\1\165\1\137\1\162\2\157\1\170\2\157\1\156\1\157\1\145"+
		"\1\167\1\171\1\156\1\157\1\150\3\uffff\1\170\1\146\23\uffff\1\75\5\uffff"+
		"\1\75\14\uffff\1\155\1\164\1\166\1\145\1\163\1\141\1\156\1\146\1\172\1"+
		"\163\1\165\1\164\1\157\1\162\1\164\1\172\1\164\1\156\1\164\1\157\1\172"+
		"\1\162\1\151\1\160\1\163\1\154\1\151\2\uffff\2\146\4\uffff\1\172\1\157"+
		"\1\164\1\157\1\145\1\170\1\156\1\145\1\157\1\141\1\145\1\162\1\164\1\141"+
		"\1\142\1\uffff\1\145\1\155\1\145\1\141\1\172\1\157\1\uffff\1\172\1\151"+
		"\1\147\1\151\1\164\1\165\1\162\1\156\1\145\1\164\1\165\1\164\1\145\1\157"+
		"\1\151\1\144\1\141\1\154\2\uffff\1\172\1\155\1\164\1\156\1\143\1\164\1"+
		"\154\1\163\1\154\1\153\2\172\1\164\1\151\1\165\1\154\2\172\1\162\1\164"+
		"\1\uffff\1\172\1\uffff\1\156\1\172\1\163\2\162\1\164\1\145\1\157\1\151"+
		"\2\143\1\144\1\156\1\147\1\172\1\164\1\145\1\uffff\1\172\1\162\1\163\1"+
		"\154\1\145\1\151\1\164\1\141\1\172\2\uffff\1\172\1\156\1\154\1\145\2\uffff"+
		"\1\156\1\172\1\uffff\1\145\1\uffff\1\164\1\151\1\156\1\172\1\144\1\146"+
		"\1\143\1\164\1\150\1\145\1\172\1\156\1\uffff\1\151\1\172\1\137\1\151\1"+
		"\164\1\163\2\156\1\162\1\164\2\uffff\1\165\1\164\2\172\1\uffff\1\172\1"+
		"\145\1\143\1\172\1\uffff\5\172\1\146\1\uffff\1\145\1\154\1\uffff\1\172"+
		"\1\142\1\172\1\160\1\163\1\145\2\151\1\145\1\172\3\uffff\1\162\1\164\6"+
		"\uffff\1\172\1\144\1\145\1\165\1\145\1\151\1\172\1\143\1\154\1\172\1\uffff"+
		"\2\172\1\uffff\2\172\1\164\1\143\1\157\1\137\1\164\1\145\5\uffff\1\145"+
		"\1\172\1\156\2\172\2\137\1\uffff\5\137\4\172\2\uffff";
	static final String DFA39_acceptS =
		"\4\uffff\1\5\1\6\4\uffff\1\20\1\21\3\uffff\1\27\1\uffff\1\34\1\42\1\43"+
		"\1\44\1\45\1\46\22\uffff\1\125\1\126\1\127\2\uffff\1\134\1\137\1\2\1\24"+
		"\1\1\1\14\1\3\1\4\1\7\1\31\1\30\1\11\1\135\1\136\1\10\1\13\1\12\1\133"+
		"\1\15\1\uffff\1\16\1\17\1\41\1\40\1\22\1\uffff\1\23\1\35\1\25\1\26\1\37"+
		"\1\36\1\33\1\32\1\54\1\53\1\56\1\55\33\uffff\1\130\1\131\2\uffff\1\52"+
		"\1\51\1\50\1\47\17\uffff\1\70\6\uffff\1\102\22\uffff\1\132\1\57\24\uffff"+
		"\1\77\1\uffff\1\103\21\uffff\1\60\11\uffff\1\62\1\63\4\uffff\1\72\1\73"+
		"\2\uffff\1\101\1\uffff\1\105\14\uffff\1\122\12\uffff\1\61\1\64\4\uffff"+
		"\1\76\4\uffff\1\111\6\uffff\1\120\2\uffff\1\124\12\uffff\1\71\1\74\1\104"+
		"\2\uffff\1\110\1\112\1\113\1\114\1\115\1\116\12\uffff\1\66\2\uffff\1\117"+
		"\10\uffff\1\65\1\106\1\107\1\121\1\123\7\uffff\1\67\11\uffff\1\100\1\75";
	static final String DFA39_specialS =
		"\u0151\uffff}>";
	static final String[] DFA39_transitionS = {
			"\2\56\1\uffff\2\56\22\uffff\1\56\1\15\1\53\1\57\1\51\1\20\1\1\1\52\1"+
			"\17\1\25\1\27\1\11\1\5\1\3\1\7\1\6\1\54\11\55\1\4\1\26\1\14\1\2\1\10"+
			"\1\22\1\uffff\32\51\1\12\1\uffff\1\23\1\30\1\32\1\uffff\1\31\1\33\1\34"+
			"\1\35\1\36\1\37\1\40\1\51\1\41\2\51\1\42\5\51\1\43\1\44\1\45\1\46\1\47"+
			"\1\50\3\51\1\13\1\16\1\24\1\21",
			"\1\61\26\uffff\1\60",
			"\1\63",
			"\1\66\17\uffff\1\67\1\65",
			"",
			"",
			"\1\72\4\uffff\1\73\15\uffff\1\71",
			"\1\75\1\uffff\12\77",
			"\1\100\1\101",
			"\1\103\21\uffff\1\104",
			"",
			"",
			"\1\107\1\106",
			"\1\111",
			"\1\114\76\uffff\1\113",
			"",
			"\1\116",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\120",
			"\1\122",
			"\1\124\1\uffff\1\125",
			"\1\126",
			"\1\127",
			"\1\130\6\uffff\1\131\6\uffff\1\132",
			"\1\133\11\uffff\1\134",
			"\1\135\1\uffff\1\136\11\uffff\1\137",
			"\1\140\2\uffff\1\141",
			"\1\142",
			"\1\143\7\uffff\1\144",
			"\1\145",
			"\1\146",
			"\1\147\1\150\12\uffff\1\151\2\uffff\1\152",
			"\1\153",
			"\1\154",
			"\1\155",
			"\1\156",
			"",
			"",
			"",
			"\1\77\1\uffff\10\161\2\77\12\uffff\3\77\21\uffff\1\157\13\uffff\3\77"+
			"\21\uffff\1\157",
			"\1\77\1\uffff\12\162\12\uffff\3\77\35\uffff\3\77",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\163",
			"",
			"",
			"",
			"",
			"",
			"\1\165",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\167",
			"\1\170",
			"\1\171\1\uffff\1\172\1\173\1\174\3\uffff\1\175\10\uffff\1\176\3\uffff"+
			"\1\177",
			"\1\u0080",
			"\1\u0081",
			"\1\u0082",
			"\1\u0083",
			"\1\u0084",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\24\51\1\u0085"+
			"\5\51",
			"\1\u0087",
			"\1\u0088",
			"\1\u0089",
			"\1\u008a",
			"\1\u008b",
			"\1\u008c",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u008f\7\uffff\1\u008e",
			"\1\u0090",
			"\1\u0091\13\uffff\1\u0092\1\u0093",
			"\1\u0094",
			"\1\u0095\22\uffff\1\u0096",
			"\1\u0097\20\uffff\1\u0098",
			"\1\u0099",
			"\1\u009a",
			"\1\u009b\11\uffff\1\u009c",
			"\1\u009d\2\uffff\1\u009e",
			"\1\u009f",
			"",
			"",
			"\1\77\1\uffff\10\161\2\77\12\uffff\3\77\35\uffff\3\77",
			"\1\77\1\uffff\12\162\12\uffff\3\77\35\uffff\3\77",
			"",
			"",
			"",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00a2",
			"\1\u00a3\1\u00a4",
			"\1\u00a5",
			"\1\u00a6",
			"\1\u00a7",
			"\1\u00a8",
			"\1\u00a9",
			"\1\u00aa",
			"\1\u00ab",
			"\1\u00ac",
			"\1\u00ad",
			"\1\u00ae\1\u00af",
			"\1\u00b0",
			"\1\u00b1",
			"",
			"\1\u00b2",
			"\1\u00b3",
			"\1\u00b4",
			"\1\u00b5",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00b7",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00b9",
			"\1\u00ba",
			"\1\u00bb",
			"\1\u00bc",
			"\1\u00bd",
			"\1\u00be",
			"\1\u00bf",
			"\1\u00c0",
			"\1\u00c1",
			"\1\u00c2",
			"\1\u00c3",
			"\1\u00c4",
			"\1\u00c5",
			"\1\u00c6",
			"\1\u00c7",
			"\1\u00c8",
			"\1\u00c9",
			"",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00cb",
			"\1\u00cc",
			"\1\u00cd",
			"\1\u00ce",
			"\1\u00cf",
			"\1\u00d0",
			"\1\u00d1",
			"\1\u00d2",
			"\1\u00d3",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00d6",
			"\1\u00d7",
			"\1\u00d8",
			"\1\u00d9",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00dc",
			"\1\u00dd",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\u00df",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00e1",
			"\1\u00e2",
			"\1\u00e3",
			"\1\u00e4",
			"\1\u00e5",
			"\1\u00e6",
			"\1\u00e7",
			"\1\u00e8",
			"\1\u00e9",
			"\1\u00ea",
			"\1\u00eb",
			"\1\u00ec",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00ee",
			"\1\u00ef",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\u00f0\1\uffff\32\51",
			"\1\u00f1",
			"\1\u00f2",
			"\1\u00f3",
			"\1\u00f4",
			"\1\u00f5",
			"\1\u00f6",
			"\1\u00f7",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u00fa",
			"\1\u00fb",
			"\1\u00fc",
			"",
			"",
			"\1\u00fd",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\u00ff",
			"",
			"\1\u0100",
			"\1\u0101",
			"\1\u0102",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0104",
			"\1\u0105",
			"\1\u0106",
			"\1\u0107",
			"\1\u0108",
			"\1\u0109",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u010b",
			"",
			"\1\u010c",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u010e",
			"\1\u010f",
			"\1\u0110",
			"\1\u0111",
			"\1\u0112",
			"\1\u0113",
			"\1\u0114",
			"\1\u0115",
			"",
			"",
			"\1\u0116",
			"\1\u0117",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u011b",
			"\1\u011c",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0123",
			"",
			"\1\u0124",
			"\1\u0125",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0126",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0127",
			"\1\u0128",
			"\1\u0129",
			"\1\u012a",
			"\1\u012b",
			"\1\u012c",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"",
			"",
			"\1\u012e",
			"\1\u012f",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0131",
			"\1\u0132",
			"\1\u0133",
			"\1\u0134",
			"\1\u0135",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\u0136\1\uffff\32\51",
			"\1\u0137",
			"\1\u0138",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u013e",
			"\1\u013f",
			"\1\u0140",
			"\1\u0141",
			"\1\u0142",
			"\1\u0143",
			"",
			"",
			"",
			"",
			"",
			"\1\u0144",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\u0146",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\u0147\1\uffff\32\51",
			"\1\u0148",
			"\1\u0149",
			"",
			"\1\u014a",
			"\1\u014b",
			"\1\u014c",
			"\1\u014d",
			"\1\u014e",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"\1\51\13\uffff\12\51\7\uffff\32\51\4\uffff\1\51\1\uffff\32\51",
			"",
			""
	};

	static final short[] DFA39_eot = DFA.unpackEncodedString(DFA39_eotS);
	static final short[] DFA39_eof = DFA.unpackEncodedString(DFA39_eofS);
	static final char[] DFA39_min = DFA.unpackEncodedStringToUnsignedChars(DFA39_minS);
	static final char[] DFA39_max = DFA.unpackEncodedStringToUnsignedChars(DFA39_maxS);
	static final short[] DFA39_accept = DFA.unpackEncodedString(DFA39_acceptS);
	static final short[] DFA39_special = DFA.unpackEncodedString(DFA39_specialS);
	static final short[][] DFA39_transition;

	static {
		int numStates = DFA39_transitionS.length;
		DFA39_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA39_transition[i] = DFA.unpackEncodedString(DFA39_transitionS[i]);
		}
	}

	protected class DFA39 extends DFA {

		public DFA39(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 39;
			this.eot = DFA39_eot;
			this.eof = DFA39_eof;
			this.min = DFA39_min;
			this.max = DFA39_max;
			this.accept = DFA39_accept;
			this.special = DFA39_special;
			this.transition = DFA39_transition;
		}
		@Override
		public String getDescription() {
			return "1:1: Tokens : ( AND | AND_ASSIGN | ASSIGN | ARROW | COLON | COMMA | DECR | DIV | DIV_ASSIGN | DOT | ELLIPSIS | EQUAL | GREATER_OR_EQUAL | GREATER_THAN | INCR | LBRACK | LCURLY | LESS_OR_EQUAL | LESS_THAN | LOGICAL_AND | LOGICAL_NOT | LOGICAL_OR | LPAREN | MINUS | MINUS_ASSIGN | MOD | MOD_ASSIGN | NOT | NOT_EQUAL | OR | OR_ASSIGN | PLUS | PLUS_ASSIGN | QUESTION | RBRACK | RCURLY | RPAREN | SEMI | SHIFT_LEFT | SHIFT_LEFT_ASSIGN | SHIFT_RIGHT | SHIFT_RIGHT_ASSIGN | STAR | STAR_ASSIGN | XOR | XOR_ASSIGN | ASM | AUTO | BREAK | CASE | CHAR | CONST | CONTINUE | DEFAULT | DECLSPEC | DO | DOUBLE | ELSE | ENUM | EXTERN | EXTENSION | FLOAT | FOR | ATTRIBUTE | GOTO | IF | INT | INLINE | LONG | REGISTER | RESTRICT | RETURN | SHORT | SIGNED | SIZEOF | STATIC | STRUCT | SWITCH | TYPEDEF | UNION | UNSIGNED | VOID | VOLATILE | WHILE | IDENTIFIER | CHARACTER_LITERAL | STRING_LITERAL | HEX_LITERAL | DECIMAL_LITERAL | OCTAL_LITERAL | FLOATING_POINT_LITERAL | WS | COMMENT | LINE_COMMENT | PREPROCESSOR_COMMAND );";
		}
	}

}
